//"$Header:$"
//-------------------  dof_accessor.templates.h  ---------------------------
//   $Id: dof_accessor.templates.h,v 1.28 2003/01/14 19:51:07 wolf Exp $
//   Version: $Name: Version-4-0-0 $
//
//   Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003 by the deal.II authors
//
//   This file is subject to QPL and may not be  distributed
//   without copyright and license information. Please refer
//   to the file deal.II/doc/license.html for the  text  and
//   further information on this license.
//
//-------------------  dof_accessor.templates.h  ---------------------------
//
//modified from deal.II/deal.II/include/dofs/dof_accessor.templates.h
//  by John Trangenstein, August 2009
#include "DofLevel.H"
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void DofLevel1::setDofs(const NumPtr<int> &new_numbers) {
  int n=dofs1.getNumber();
  for (int i=0;i<n;i++) {
    int &di=dofs1[i];
    if (di!=invalid_dof_index) di=new_numbers[di];
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void DofLevel1::setDofs(const Shape1 *element,int dpl,
int &next_free_dof) {
  NumPtr<int> edn(dofs1,element->dofIndex(),dpl);
#if (SPACEDIM>1)
  if (edn[0]==invalid_dof_index)
#endif
  {
    for (int d=0;d<dpl;d++,next_free_dof++) edn[d]=next_free_dof;
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void DofLevel1::printOn(ostream &os) const {
  os << "DofLevel1: " << endl;
  for (int i=0;i<dofs1.getNumber();i++) {
    os << "\tdofs1[" << i << "] = " << dofs1[i] << endl;
  }
}
#if (SPACEDIM>1)
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void DofLevel2::setDofs(const NumPtr<int> &new_numbers) {
  int n=dofs2.getNumber();
  for (int i=0;i<n;i++) {
    int &di=dofs2[i];
    if (di!=invalid_dof_index) di=new_numbers[di];
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void DofLevel2::setDofs(const Shape2 *element,int dpq,
int &next_free_dof) {
  NumPtr<int> edn(dofs2,element->dofIndex(),dpq);
#if (SPACEDIM>2)
  if (edn[0]==invalid_dof_index)
#endif
  {
    for (int d=0;d<dpq;d++,next_free_dof++) edn[d]=next_free_dof;
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void DofLevel2::printOn(ostream &os) const {
  os << "DofLevel2: " << endl;
  for (int i=0;i<dofs2.getNumber();i++) {
    os << "\tdofs2[" << i << "] = " << dofs2[i] << endl;
  }
  DofLevel1::printOn(os);
}
#endif
#if (SPACEDIM==3)
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void DofLevel3::setDofs(const NumPtr<int> &new_numbers) {
  int n=dofs3.getNumber();
  for (int i=0;i<n;i++) {
    int &di=dofs3[i];
    if (di!=invalid_dof_index) di=new_numbers[di];
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void DofLevel3::setDofs(const Shape3 *element,int dph,
int &next_free_dof) {
  NumPtr<int> edn(dofs3,element->dofIndex(),dph);
  for (int d=0;d<dph;d++,next_free_dof++) edn[d]=next_free_dof;
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void DofLevel3::printOn(ostream &os) const {
  os << "DofLevel3: " << endl;
  for (int i=0;i<dofs3.getNumber();i++) {
    os << "\tdofs3[" << i << "] = " << dofs3[i] << endl;
  }
  DofLevel2::printOn(os);
}
#endif
