//"$Header:$"
#include "HcurlDofLevel.H"
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void HcurlDofLevel::setDofs(const NumPtr<int> &new_numbers) {
  int n=dofs.getNumber();
  for (int i=0;i<n;i++) {
    int &di=dofs[i];
    if (di!=invalid_dof_index) di=new_numbers[di];
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void HcurlDofLevel::setDofs(int dof_index,int dps,
int &next_free_dof) {
  NumPtr<int> edn(dofs,dof_index,dps);
  if (edn[0]==invalid_dof_index) {
    for (int d=0;d<dps;d++,next_free_dof++) edn[d]=next_free_dof;
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void HcurlDofLevel::setCodimension1Dofs(const NumPtr<int> &new_numbers){
  int n=codimension1_dofs.getNumber();
  for (int i=0;i<n;i++) {
    int &di=codimension1_dofs[i];
    if (di!=invalid_dof_index) di=new_numbers[di];
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void HcurlDofLevel::setCodimension1Dofs(int dof_index,int dpcs,
int &next_free_dof) {
  NumPtr<int> edn(codimension1_dofs,dof_index,dpcs);
  if (edn[0]==invalid_dof_index) {
    for (int d=0;d<dpcs;d++,next_free_dof++) edn[d]=next_free_dof;
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#if (SPACEDIM==3)
void HcurlDofLevel::setCodimension2Dofs(const NumPtr<int> &new_numbers){
  int n=codimension2_dofs.getNumber();
  for (int i=0;i<n;i++) {
    int &di=codimension2_dofs[i];
    if (di!=invalid_dof_index) di=new_numbers[di];
  }
}
#endif
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#if (SPACEDIM==3)
void HcurlDofLevel::setCodimension2Dofs(int dof_index,int dpl,
int &next_free_dof) {
  NumPtr<int> edn(codimension2_dofs,dof_index,dpl);
  if (edn[0]==invalid_dof_index) {
    for (int d=0;d<dpl;d++,next_free_dof++) edn[d]=next_free_dof;
  }
}
#endif
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void HcurlDofLevel::setMultiplierDofs(const NumPtr<int> &new_numbers) {
  int n=multiplier_dofs.getNumber();
  for (int i=0;i<n;i++) {
    int &di=multiplier_dofs[i];
    if (di!=invalid_dof_index) di=new_numbers[di];
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void HcurlDofLevel::setMultiplierDofs(int element_data_index,int apdps,
int &next_free_dof) {
  map<int,int>::const_iterator edi2apim_iterator=
    element_data_index_to_multiplier_index_map.find(element_data_index);
  CHECK_TEST(edi2apim_iterator!=
    element_data_index_to_multiplier_index_map.end());
  NumPtr<int> edn(multiplier_dofs,edi2apim_iterator->second,apdps);
  if (edn[0]==invalid_dof_index) {
    for (int d=0;d<apdps;d++,next_free_dof++) edn[d]=next_free_dof;
  }
}
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
/*
#if (SPACEDIM==2)
void HcurlDofLevel::setMultiplierCodimension1Dofs(
int face_element_data_index,int apcd1dps,int &next_free_dof) {
  map<int,int>::const_iterator fedi2apim_iterator=
    face_element_data_index_to_multiplier_index_map.
      find(face_element_data_index);
  CHECK_TEST(fedi2apim_iterator!=
    face_element_data_index_to_multiplier_index_map.end());
  NumPtr<int> edn(multiplier_codimension1_dofs,
    fedi2apim_iterator->second,apcd1dps);
  if (edn[0]==invalid_dof_index) {
    for (int d=0;d<apcd1dps;d++,next_free_dof++) edn[d]=next_free_dof;
  }
}
#endif
*/
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
void HcurlDofLevel::printOn(ostream &os) const {
  os << "HcurlDofLevel: " << endl;
  for (int i=0;i<dofs.getNumber();i++) {
    os << "\tdofs[" << i << "] = " << dofs[i] << endl;
  }
  for (int i=0;i<codimension1_dofs.getNumber();i++) {
    os << "\tcodimension1_dofs[" << i << "] = " << codimension1_dofs[i]
       << endl;
  }
#if (SPACEDIM==3)
  for (int i=0;i<codimension2_dofs.getNumber();i++) {
    os << "\tcodimension2_dofs[" << i << "] = " << codimension2_dofs[i]
       << endl;
  }
#endif
  for (int i=0;i<multiplier_dofs.getNumber();i++) {
    os << "\tmultiplier_dofs[" << i << "] = " << multiplier_dofs[i]
       << endl;
  }
/*
  for (int i=0;i<multiplier_codimension1_dofs.getNumber();i++) {
    os << "\tmultiplier_codimension1_dofs[" << i << "] = "
       << multiplier_codimension1_dofs[i] << endl;
  }
*/
  for (map<int,int>::const_iterator edi2apim_iterator=
  element_data_index_to_multiplier_index_map.begin();
  edi2apim_iterator!=element_data_index_to_multiplier_index_map.end();
  edi2apim_iterator++) {
    os << "\telement_data_index_to_multiplier_index_map : "
       << edi2apim_iterator->first << " -> "
       << edi2apim_iterator->second << endl;
  }
/*
  for (map<int,int>::const_iterator fedi2apim_iterator=
  face_element_data_index_to_multiplier_index_map.begin();
  fedi2apim_iterator!=face_element_data_index_to_multiplier_index_map.end();
  fedi2apim_iterator++) {
    os << "\telement_data_index_to_multiplier_index_map : "
       << fedi2apim_iterator->first << " -> "
       << fedi2apim_iterator->second << endl;
  }
*/
}
