# "$Header: /home/faculty/johnt/cvs/gnu/macros.gnu,v 1.4 2002/03/22 20:09:03 johnt Exp $"

MACHINE = $(shell uname -m)
OS_NAME = $(shell uname -s)

#ifeq ($(MACHINE),i686)
include $(DIR_BASE)/gnu/duke.math.gnu
#endif

DEBUGFLAGS := $(DEBUGFLAGS) $(MEMFLAGS) -DDEBUG -DINDEF -DTIMING
#DEBUGFLAGS := $(DEBUGFLAGS) $(MEMFLAGS) -DDEBUG -DINDEF -DTIMING -DNO_THREAD -DUSE_GTK
OPTFLAGS := $(OPTFLAGS) $(MEMFLAGS) -DTIMING
#OPTFLAGS := $(OPTFLAGS) $(MEMFLAGS) -DTIMING -DNO_THREAD -DUSE_GTK

ifneq ($(DIM), )
  CFLAGS := $(CFLAGS) -DSPACEDIM=$(DIM)
  CPPFLAGS := $(CPPFLAGS) -DSPACEDIM=$(DIM)
  FFLAGS := $(FFLAGS) -DSPACEDIM=$(DIM)
endif

ifeq ($(OPT),d)
  CFLAGS := $(CFLAGS) $(DEBUGFLAGS)
  CPPFLAGS := $(CPPFLAGS) $(DEBUGFLAGS)
  FFLAGS = $(DEBUGFFLAGS)
  FORT_DEBUG = 1
  LIB_SUFFIX = a
endif
  
ifeq ($(OPT),o)
  CFLAGS := $(CFLAGS) $(OPTFLAGS)
  CPPFLAGS := $(CPPFLAGS) $(OPTFLAGS)
  FFLAGS = $(OPTFFLAGS)
  FORT_DEBUG = 0
  LIB_SUFFIX = a
endif

MEMDEBUG_DIR = $(DIR_BASE)/memdebug
GRAPHICS_DIR = $(DIR_BASE)/graphics
GUI_DIR = $(DIR_BASE)/gui

MEMDEBUG_ODIR = $(MEMDEBUG_DIR)/$(OPT)
GRAPHICS_ODIR = $(GRAPHICS_DIR)/$(DIM)$(OPT)
GUI_ODIR = $(GUI_DIR)/$(OPT)

MEMDEBUG_LIB = $(MEMDEBUG_ODIR)/libmemdebug.$(LIB_SUFFIX)
GRAPHICS_LIB = $(GRAPHICS_ODIR)/libgraphics.$(LIB_SUFFIX)
GUI_LIB = $(GUI_ODIR)/libgui.$(LIB_SUFFIX)

ifneq ( ,$(cSOURCES))
  cOBJECTS = $(foreach SOURCE, $(cSOURCES), $(OD)/$(subst .c,.o,$(SOURCE)))
endif
ifneq ( ,$(CSOURCES))
  COBJECTS = $(foreach SOURCE, $(CSOURCES), $(OD)/$(subst .C,.o,$(SOURCE)))
endif
ifneq ( ,$(fSOURCES))
  fOBJECTS = $(foreach SOURCE, $(fSOURCES), $(OD)/$(subst .f,.o,$(SOURCE)))
endif
ifneq ( ,$(m4SOURCES))
  m4OBJECTS = $(foreach SOURCE, $(m4SOURCES), $(OD)/$(subst .m4,.o,$(SOURCE)))
endif

OBJECTS = $(COBJECTS) $(cOBJECTS) $(fOBJECTS) $(m4OBJECTS)
