#!/usr/bin/perl -w
# "$Header: /home/faculty/johnt/cvs/deal/gnu/macros.pl,v 1.1.1.1 2004/08/23 18:42:39 johnt Exp $"

use File::Basename;
use POSIX qw(uname);
use Sys::Hostname;

$USE_GTK="1";
if (not defined($DEAL_DIR)) { $DEAL_DIR = dirname($SD); }

#sub setOSVersion {
#  open issue_file, "/etc/issue"
#    or die "no /etc/issue on this $MACHINE: $!";
#  chomp($line=<issue_file>);
#  @fields = split /\s+/, $line;
#  pop @fields;
#  $OS_VERSION=pop @fields;
#  close issue_file;
#}

#given file.*, returns file.o
sub object {
  my $arg=$_[0];
  {
    $_=$arg;
    s/\.\w+/.o/;
    return $_;
  }
}

#given source_directory, returns object_directory
sub setOD {
  my($DIM,$OPT) = @_;
  return $SD . "/" . $DIM . $OPT;
}

#given optimization option, returns library suffix
sub libSuffix {
  my($OPT) = @_;
# return ($OPT eq "d") ? "a" : "a";
  return "a";
}

sub gnuDir {
  return $DEAL_DIR . "/gnu";
}

sub memdebugDir {
  return $DEAL_DIR . "/memdebug";
}
sub memdebugODir {
  my($OPT) = @_;
  return &memdebugDir . "/" . $OPT;
}
sub memdebugLib {
  my($OPT) = @_;
  return &memdebugODir($OPT) . "/" . "libmemdebug." 
    . &libSuffix($OPT);
}

sub graphicsDir {
  return $DEAL_DIR . "/graphics";
}
sub graphicsODir {
  my($DIM,$OPT) = @_;
  return &graphicsDir . "/" . $DIM . $OPT;
}
sub graphicsLib {
  my($DIM,$OPT) = @_;
  return &graphicsODir($DIM,$OPT) . "/" . "libgraphics." 
    . &libSuffix($OPT);
}

sub guiDir {
  return dirname($SD) . "/gui"; 
}
sub guiODir {
  my($OPT) = @_;
  return &guiDir . "/" . $OPT; 
}
sub guiLib {
  my($OPT) = @_;
  return &guiODir($OPT) . "/" . "libgui." . &libSuffix($OPT);
}

sub baseDir {
  return $DEAL_DIR . "/base";
}
sub baseODir {
  my($DIM,$OPT) = @_;
  return &baseDir . "/" . $DIM . $OPT;
}
sub baseLib {
  my($DIM,$OPT) = @_;
  return &baseODir($DIM,$OPT) . "/" . "libbase." . &libSuffix($OPT);
}

sub solverDir {
  return $DEAL_DIR . "/solver";
}
sub solverODir {
  my($OPT) = @_;
  return &solverDir . "/" . $OPT;
}
sub solverLib {
  my($OPT) = @_;
  return &solverODir($OPT) . "/" . "libsolver." . &libSuffix($OPT);
}

sub feDir {
  return $DEAL_DIR . "/fe";
}
sub feODir {
  my($DIM,$OPT) = @_;
  return &feDir . "/" . $DIM . $OPT;
}
sub feLib {
  my($DIM,$OPT) = @_;
  return &feODir($DIM,$OPT) . "/" . "libfe." 
         . &libSuffix($OPT);
}

sub mgDir {
  return $DEAL_DIR . "/mg";
}
sub mgODir {
  my($DIM,$OPT) = @_;
  return &mgDir . "/" . $DIM . $OPT;
}
sub mgLib {
  my($DIM,$OPT) = @_;
  return &mgODir($DIM,$OPT) . "/" . "libmg." 
         . &libSuffix($OPT);
}
  
sub dealLibs {
  my($DIM,$OPT) = @_;
  return &mgLib($DIM,$OPT)
    . " " . &feLib($DIM,$OPT)
    . " " . &solverLib($DIM,$OPT)
    . " " . &baseLib($DIM,$OPT)
    . " " . &guiLib($DIM,$OPT)
    . " " . &graphicsLib($DIM,$OPT)
    . " " . &memdebugLib($OPT);
}
               ;
sub macros {
# print "entering macros\n";
  my($SOURCES_REF,$DIM_REF)=@_;
  my($CSOURCES_REF,$cSOURCES_REF,$fSOURCES_REF,$m4SOURCES_REF) =
    ($SOURCES_REF->[0],$SOURCES_REF->[1],$SOURCES_REF->[2],
     $SOURCES_REF->[3]);
# foreach $SOURCE (@$fSOURCES_REF) {
#   print "fSOURCE = " . $SOURCE . "\n";
# }
  $MACHINE = (uname)[4];

  $DIR_BASE = dirname($SD);
  $LIB_BASE = basename($SD);
# print "DIR_BASE = " . $DIR_BASE . "\n";
# print "LIB_BASE = " . $LIB_BASE . "\n";

  $DEBUGCFLAGS = "";
  $DEBUGCPPFLAGS = "";
  $DEBUGFFLAGS = "";
  $OPTCFLAGS = "";
  $OPTCPPFLAGS = "";
  $OPTFFLAGS = "";
  require $GNU_DIR . "/duke.math.pl";
  &setI686;

  if ($USE_GTK eq "1") {
    $DEBUGCPPFLAGS .= " " . $MEMFLAGS . 
      " -DDEBUG -DINDEF -DTIMING -DNO_THREAD -DUSE_GTK";
    $OPTCPPFLAGS .= " " . $MEMFLAGS . " -DTIMING -DNO_THREAD -DUSE_GTK";
  } else {
    $DEBUGCPPFLAGS .= " " . $MEMFLAGS . " -DDEBUG -DINDEF -DTIMING";
    $OPTCPPFLAGS .= " " . $MEMFLAGS . " -DTIMING";
  }

  foreach $SOURCE (@$CSOURCES_REF) { $SOURCE .= ".C"; } 
  foreach $SOURCE (@$cSOURCES_REF) { $SOURCE .= ".c"; } 
  foreach $SOURCE (@$fSOURCES_REF) { $SOURCE .= ".f"; } 
  foreach $SOURCE (@$m4SOURCES_REF) { $SOURCE .= ".m4"; }

  @COBJECTS = ();
  foreach $SOURCE (@$CSOURCES_REF) {
    push ( @COBJECTS, &object($SOURCE) );
  }
  @cOBJECTS = ();
  foreach $SOURCE (@$cSOURCES_REF) {
    push ( @cOBJECTS, &object($SOURCE) );
  }
  @fOBJECTS = ();
  foreach $SOURCE (@$fSOURCES_REF) {
    push ( @fOBJECTS, &object($SOURCE) );
  }
  @m4OBJECTS = ();
  foreach $SOURCE (@$m4SOURCES_REF) {
    push ( @m4OBJECTS, &object($SOURCE) );
  }
  
  $MAKE = "make -f $GNU_DIR/GNUmakefile";
  unless ($LIB_BASE eq "memdebug") { 
#   $_ = $INCLUDE_OPTION;
    if ($USE_GTK eq "1") {
      $FULL_INCLUDE_OPTION = $INCLUDE_OPTION . " -I$PANGOINCDIR -I$GTKINCDIR -I$GDKINCDIR -I$GLIBINCDIR -I$SIGCINCDIR -I$ATKINCDIR -I$GTKGLINCDIR";
    } else {
      $FULL_INCLUDE_OPTION = $INCLUDE_OPTION . " -I$XMINCDIR";
    }
  }
# print "INCLUDE_OPTION = " . $INCLUDE_OPTION . "\n";
# print "FULL_INCLUDE_OPTION = " . $FULL_INCLUDE_OPTION . "\n";
}

sub fixOptions {
  my($OPTIONS_REF) = @_;
  if ($#{ $OPTIONS_REF->[0] } < 0) { ${ $OPTIONS_REF->[0] }[0] = ""; }
# if ($#{ $OPTIONS_REF->[1] } < 0) { ${ $OPTIONS_REF->[1] }[0] = ""; }
}

sub makeCase {
# print "entering makeCase\n";
# print "USE_GTK = " . $USE_GTK . "\n";
# print "FULL_INCLUDE_OPTION = " . $FULL_INCLUDE_OPTION . "\n";
  my($DIM,$OPT,$MAKE_TARGET,$MAIN,$PROGRAM_NAME,$ULIBS) = @_;
# print "MAKE_TARGET = " . $MAKE_TARGET . "\n";
  my($OD)=&setOD($DIM,$OPT);
  my($LIB_SUFFIX)= &libSuffix($OPT);
  if ($OPT eq "d") {
    $CFLAGS = $DEBUGCFLAGS;
    $CPPFLAGS = $DEBUGCPPFLAGS;
    $FFLAGS = $DEBUGFFLAGS;
    $FORT_DEBUG = 1;
  } elsif ($OPT eq "o") {
    $CFLAGS = $OPTCFLAGS;
    $CPPFLAGS = $OPTCPPFLAGS;
    $FFLAGS = $OPTFFLAGS;
    $FORT_DEBUG = 0;
  }
  if (not defined($DIM)) { $DIM=""; }
  if ($DIM ne "") { 
    $CPPFLAGS .= " -DSPACEDIM=" . $DIM; 
  }
  @OBJECTS = (@COBJECTS, @cOBJECTS, @fOBJECTS, @m4OBJECTS);
  foreach $OBJECT (@OBJECTS) { $OBJECT = $OD . "/" . $OBJECT; }
  if ( defined($MAIN) ) { $MAIN .= ".o"; }
  unless (-e $OD) {
    mkdir $OD , 0700 or die "Cannot mkdir $OD: $!";
  }
  $DEPENDS_GNU = $OD . "/depends.gnu";
  unless (-e $DEPENDS_GNU) {
    system "touch " . $DEPENDS_GNU;
    chmod 0600, $DEPENDS_GNU;
  }
  unlink glob("$SD/m4amr.i");
  $make_cmd = "$MAKE " . $MAKE_TARGET
            . " OPT=$OPT"
            . " DIM=$DIM"
            . " SD=$SD"
            . " OD=$OD"
            . " MAIN=$MAIN"
            . " LIB_SUFFIX=$LIB_SUFFIX"
            . " LIB_BASE=$LIB_BASE"
            . " FORT_DEBUG=$FORT_DEBUG"
            . " GNU_DIR=" . &gnuDir
            . " MEMDEBUG_DIR=" . &memdebugDir
            . " BASE_DIR=" . &baseDir
            . " MAKE=" . '"' . "$MAKE" . '"'
            . " OBJECTS=" . '"' . "@OBJECTS" . '"'
            . " m4OBJECTS=" . '"' . "@m4OBJECTS" . '"'
            . " DSO=" . '"' . $DSO . '"'
            . " DSO_FLAGS=" . '"' . $DSO_FLAGS . '"'
            . " INCLUDE_OPTION=" . '"' . $FULL_INCLUDE_OPTION . '"'
            . " CPLUSPLUS=" . '"' . $CPLUSPLUS . '"'
            . " CC=" . '"' . $CC . '"'
            . " CFLAGS=" . '"' . $CFLAGS . '"'
            . " CPPFLAGS=" . '"' . $CPPFLAGS . '"'
            . " M4=" . '"' . $M4 . '"'
            . " M4FLAGS=" . '"' . $M4FLAGS . '"'
            . " FC=" . '"' . $FC . '"'
            . " FFLAGS=" . '"' . $FFLAGS . '"'
            . " MACHINE=" . '"' . $MACHINE . '"'
            . " LINK.C=" . '"' . $LINKC . '"'
            . " PROGRAM_NAME=" . '"' . $PROGRAM_NAME . '"'
            . " ULIBS=" . '"' . "$ULIBS" . '"'
            . " SLIBS=" . '"' . $SLIBS . '"';
# print "make_cmd = " . $make_cmd . "\n";
  system $make_cmd;
  unlink glob("$SD/m4amr.i");
# print "leaving makeCase\n";
}

sub processCommandLineForLibrary {
# print "entering processCommandLineForLibrary\n";
  my($target)=@_;
  if (not defined($target)) { $target = "libs"; }
# print "target = " . $target . "\n";

  if ($target eq "libs") {
#   print "target = libs\n";
    my(@SOURCES,@OPTIONS);
    &libOptions(\@OPTIONS);
    &fixOptions(\@OPTIONS);
    $ULIBS="";
    foreach $DIM ( @{ $OPTIONS[0] } ) {
#     print "DIM = " . $DIM . "\n";
      &libSources(\@SOURCES,$DIM);
      &macros(\@SOURCES,$DIM);
#     print "CSOURCES = " . $SOURCES->[0] . "\n";
#     print "cSOURCES = " , $SOURCES->[1] , "\n";
#     print "fSOURCES = " , $SOURCES->[2] , "\n";
#     print "m4SOURCES = " , $SOURCES->[3] , "\n";
      foreach $OPT ( @{ $OPTIONS[1] } ) {
#       print "OPT = " . $OPT . "\n";
        my($OD)=&setOD($DIM,$OPT);
        my($MAKE_TARGET) = 
          "$OD" . "/lib" . "$LIB_BASE." . &libSuffix($OPT);
        my($PROGRAM_NAME) = "nothing"; 
        &makeCase($DIM,$OPT,$MAKE_TARGET,"",$PROGRAM_NAME,$ULIBS);
      }
    }
  } elsif (($target eq "all") || ($target eq "cleanall")) {
#   print "target = all or cleanall\n";
    foreach $PROGRAM (@PROGRAMS) {
    my(@SOURCES,@OPTIONS);
      &programOptions($PROGRAM,\@OPTIONS);
      &fixOptions(\@OPTIONS);
      foreach $DIM ( @{ $OPTIONS[0] } ) {
#       print "DIM = " . $DIM . "\n";
        &programSources($PROGRAM,\@SOURCES,$DIM);
        &macros(\@SOURCES,$DIM);
#       print "CSOURCES = " . $SOURCES->[0] . "\n";
#       print "cSOURCES = " , $SOURCES->[1] , "\n";
#       print "fSOURCES = " , $SOURCES->[2] , "\n";
#       print "m4SOURCES = " , $SOURCES->[3] , "\n";
        foreach $OPT ( @{ $OPTIONS[1] } ) {
#         print "OPT = " . $OPT . "\n";
          if ($target eq "all") {
            my($OD)=&setOD($DIM,$OPT);
            my($MAKE_TARGET) = "$OD" . "/" . $PROGRAM;
            my($ULIBS) = programLibs($PROGRAM,$DIM,$OPT);
            my($MAIN) = &programMain($PROGRAM,$DIM,$OPT);
#           print "MAIN = " . $MAIN . "\n";
            &makeCase($DIM,$OPT,$MAKE_TARGET,$MAIN,$PROGRAM,$ULIBS);
          } elsif ($target eq "cleanall") {
#           print "target = cleanall\n";
#           print "OBJECTS = " . @OBJECTS . "\n";
            my($OD)=&setOD($DIM,$OPT);
            my($MAIN) = programMain($PROGRAM,$DIM,$OPT) . ".o";
            my($make_cmd) = "$MAKE cleanprogram "
                          . " OD=$OD"
                          . " MAIN=$MAIN"
                          . " OBJECTS=" . '"' . "@OBJECTS" . '"'
                          . " PROGRAM_NAME=" . '"' . $PROGRAM . '"';
            system $make_cmd;
          }
        }
      }
    }
  } elsif (($target eq "nolibs") || ($target eq "nodepends") ||
  ($target eq "clean")) {
    my(@OPTIONS);
    &libOptions(\@OPTIONS);
    &fixOptions(\@OPTIONS);
    foreach $DIM ( @{ $OPTIONS[0] } ) {
      foreach $OPT ( @{ $OPTIONS[1] } ) {
        my($OD)=&setOD($DIM,$OPT);
#       print "OD = " . $OD . "\n";
        if ($target eq "clean") {
          unlink glob("$OD/*.[fo]*");
          unlink glob("$OD/*." . &libSuffix($OPT));
          unlink glob("$OD/*.gnu");
          unlink "$OD/m4amr.i";
        } elsif ($target eq "nolibs") {
          unlink glob("$OD/*." . &libSuffix($OPT));
        } elsif ($target eq "nodepends") {
          unlink glob("$OD/*.[d]*");
          unlink "$OD/depends.gnu";
        }
      }
    }
  } elsif ($target eq "release") {
    system "$MAKE release";
  }
}

sub processCommandLine {
# print "entering processCommandLine\n";
# print "USE_GTK = " . $USE_GTK . "\n";
  my($target)=@_;
  if (not defined($target)) { $target = "all"; }
# print "target = " . $target . "\n";
  if (($target eq "all") || ($target eq "clean") ||
  ($target eq "cleanall")) {
#   print "in all or clean or cleanall\n";
    foreach $PROGRAM (@PROGRAMS) {
      my(@SOURCES,@OPTIONS);
      &programOptions($PROGRAM,\@OPTIONS);
      &fixOptions(\@OPTIONS);
      foreach $DIM ( @{ $OPTIONS[0] } ) {
        &programSources($PROGRAM,\@SOURCES,$DIM);
        &macros(\@SOURCES,$DIM);
        foreach $OPT ( @{ $OPTIONS[1] } ) {
          my($OD)=&setOD($DIM,$OPT);
          if ($target eq "all") {
            my($MAKE_TARGET) = "$OD" . "/" . $PROGRAM;
            my($ULIBS) = programLibs($PROGRAM,$DIM,$OPT);
            my($MAIN) = &programMain($PROGRAM,$DIM,$OPT);
#             print "calling makeCase\n";
#             print "MAKE_TARGET = " . $MAKE_TARGET . "\n";
            &makeCase($DIM,$OPT,$MAKE_TARGET,$MAIN,$PROGRAM,$ULIBS);
          } else {
            my($MAIN) = programMain($PROGRAM,$DIM,$OPT) . ".o";
            @OBJECTS = (@COBJECTS, @cOBJECTS, @fOBJECTS, @m4OBJECTS);
            foreach $OBJECT (@OBJECTS) { 
              $OBJECT = $OD . "/" . $OBJECT; 
            }
#           print "PROGRAM = " . $PROGRAM . "\n";
#           print "DIM = " . $DIM . "\n";
#           print "OPT = " . $OPT . "\n";
#           print "OBJECTS = " . @OBJECTS . "\n";
            print "making cleanprogram in ", $OD, "\n";
            unlink glob("$OD/*.[f]*");
            my($make_cmd) = "$MAKE cleanprogram "
                          . " OD=$OD"
                          . " MAIN=$MAIN"
                          . " OBJECTS=" . '"' . "@OBJECTS" . '"'
                          . " PROGRAM_NAME=" . '"' . $PROGRAM . '"';
            system $make_cmd;
          }
        }
      }
    }
  } elsif ($target eq "nodepends") {
    my(@OPTIONS);
    &programOptions($PROGRAM,\@OPTIONS);
    &fixOptions(\@OPTIONS);
    foreach $DIM ( @{ $OPTIONS[0] } ) {
      foreach $OPT ( @{ $OPTIONS[1] } ) {
        my($OD)=&setOD($DIM,$DIST,$OPT);
        if ($target eq "nodepends") {
          print "removing *.d in ", $OD, "\n";
          unlink glob("$OD/*.[d]*");
          unlink "$OD/depends.gnu";
        }
      }
    }
  } elsif ($target eq "release") {
    system "$MAKE release";
  }
# print "leaving processCommandLine\n";
}

1;
