# "$Header: /home/faculty/johnt/cvs/gnu/targets.gnu,v 1.13 2003/10/15 11:45:36 johnt Exp $"

#recall that
#  $@ = name of current target
#  $? = list of dependencies newer than the target
#  $< = name of the dependency file, as if selected by make for use with
#       an implicit rule
#  $^ = the dependency list
#  $* = the basename of the current target
#  $% = the name of the library member being processed
#
#  $(@F) = filename part of a target
#  $(@D) = directory part of a target (= . if no / in value)

$(OBJECTS) : $(SD)/m4amr.i

$(OD)/%.o: $(SD)/%.C
	$(C++) $(CPPFLAGS) $(INCLUDE_OPTION) -c -o $@ $(SD)/$*.C

$(OD)/%.o: $(SD)/%.m4
	-chmod ug+wr $(OD)/$*.f
	$(M4) $(M4FLAGS) $(SD)/$*.m4 > $(OD)/$*.f
	$(FC) $(FFLAGS) -c -o $@ $(OD)/$*.f 
	test -s $@
	touch $(OD)/$*.d
ifeq ($(MACHINE),alpha)
	echo "$*.o : $(SD)/$*.m4" > $(OD)/$*.d
else
	echo "$(OD)/$*.o : $(SD)/$*.m4" > $(OD)/$*.d
endif

$(OD)/%.o: $(SD)/%.f
	$(FC) $(FFLAGS) -c -o $@ $(SD)/$*.f
	test -s $@
	touch $(OD)/$*.d
	echo "$*.o : $(SD)/$*.f" > $(OD)/$*.d

$(OD)/%.o: $(SD)/%.c
	$(CC) $(CFLAGS) $(INCLUDE_OPTION) -c -o $@ $(SD)/$*.c

dependstest :
	@echo OD = $(OD)

depends :
	-$(RM) $(OD)/depends.gnu
ifeq ($(MACHINE),alpha) 
	cat $(OD)/*.d | sed -e "/ \/usr\/lib/d" > $(OD)/depends.temp
	sed -e "/ \/usr\/include/d" $(OD)/depends.temp \
	  > $(OD)/depends.temp2
	awk '{printf("%s%s\n","$(OD)/",$$0)}' $(OD)/depends.temp2 \
	  > $(OD)/depends.gnu
	rm $(OD)/depends.temp
	rm $(OD)/depends.temp2
else
	cat $(OD)/*.d > $(OD)/depends.gnu
endif

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

define libmake
	OD=$(SD)/$$DIM$$DIST$$OPT; \
	touch $(SD)/m4amr.i; $(RM) $(SD)/m4amr.i ; \
	if test ! -d  $$OD ; then mkdir $$OD ; fi; \
	touch $$OD/depends.gnu ; \
	$(MAKE) libinstance DIM=$$DIM DIST=$$DIST OPT=$$OPT OD=$$OD ;
endef

libs :
ifeq ($(DIM_OPTIONS), )
ifeq ($(DIST_OPTIONS), )
	for OPT in $(OPT_OPTIONS) ; do \
	  $(libmake) \
	done
else
	for DIST in $(DIST_OPTIONS) ; do \
	  for OPT in $(OPT_OPTIONS) ; do \
	    $(libmake) \
	  done ; \
	done
endif
else
ifeq ($(DIST_OPTIONS), )
	for DIM in $(DIM_OPTIONS) ; do \
	  for OPT in $(OPT_OPTIONS) ; do \
	    $(libmake) \
	  done ; \
	done
else
	for DIM in $(DIM_OPTIONS) ; do \
	  for DIST in $(DIST_OPTIONS) ; do \
	    for OPT in $(OPT_OPTIONS) ; do \
	      $(libmake) \
	    done ; \
	  done ; \
	done
endif
endif

libtest :
	@echo OD = $(OD)
	@echo OBJECTS = $(OBJECTS)

libinstance:
ifeq ($(LIB_SUFFIX),so)
	$(MAKE) $$OD/lib$(LIB_BASE).so DIM=$$DIM DIST=$$DIST \
	  OPT=$$OPT  OD=$$OD ;
else
	$(MAKE) $$OD/lib$(LIB_BASE).a DIM=$$DIM DIST=$$DIST \
	  OPT=$$OPT  OD=$$OD ;
endif

$(OD)/lib$(LIB_BASE).so : $(SD)/m4amr.i $(OBJECTS)
	$(DSO) $(DSO_FLAGS) $(OBJECTS) -o $(OD)/lib$(LIB_BASE).so
	chmod a+r $(OD)/lib$(LIB_BASE).so
	$(MAKE) depends OD=$(OD)
	$(RM) $(SD)/m4amr.i

$(OD)/lib$(LIB_BASE).a : $(SD)/m4amr.i $(OBJECTS)
	$(AR) $(ARFLAGS) $(OD)/lib$(LIB_BASE).a $(OBJECTS)
	chmod a+r $(OD)/lib$(LIB_BASE).a
	$(MAKE) depends OD=$(OD)
	$(RM) $(SD)/m4amr.i

#lib : $(SD)/m4amr.i $(OBJECTS)
#ifeq ($(LIB_SUFFIX),so)
#	$(DSO) $(DSO_FLAGS) $(OBJECTS) -o $(OD)/lib$(LIB_BASE).so
#	chmod a+r $(OD)/lib$(LIB_BASE).so
#	$(MAKE) depends OD=$(OD)
#	$(RM) $(SD)/m4amr.i
#else
#	$(AR) $(ARFLAGS) $(OD)/lib$(LIB_BASE).a $(OBJECTS)
#	chmod a+r $(OD)/lib$(LIB_BASE).a
#	$(MAKE) depends OD=$(OD)
#	$(RM) $(SD)/m4amr.i
#endif

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

define libclean 
	OD=$(SD)/$$DIM$$DIST$$OPT; \
	if test -d  $$OD ; then \
	  echo removing in $$OD ; \
	  rm -rf  $$OD/*.[dfo] ; \
	  rm -rf  $$OD/*.a ; \
	  rm -rf  $$OD/*.so ; \
	  rm -rf  $$OD/*.gnu ; \
	  rm -rf  $$OD/m4amr.i ; \
	fi;
endef

clean :
ifeq ($(DIM_OPTIONS), )
ifeq ($(DIST_OPTIONS), )
	for OPT in $(OPT_OPTIONS) ; do \
	  $(libclean) \
	done 
else
	for DIST in $(DIST_OPTIONS) ; do \
	  for OPT in $(OPT_OPTIONS) ; do \
	    $(libclean) \
	  done ; \
	done
endif
else
ifeq ($(DIST_OPTIONS), )
	for DIM in $(DIM_OPTIONS) ; do \
	  for OPT in $(OPT_OPTIONS) ; do \
	    $(libclean) \
	  done ; \
	done
else
	for DIM in $(DIM_OPTIONS) ; do \
	  for DIST in $(DIST_OPTIONS) ; do \
	    for OPT in $(OPT_OPTIONS) ; do \
	      $(libclean) \
	    done ; \
	  done ; \
	done
endif
endif

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

all :
	for p in $(PROGRAMS) ; do \
	  $(MAKE) programs PROGRAM_NAME=$$p ; \
	done

programs :
ifeq ($(DIM_OPTIONS), )
ifeq ($(DIST_OPTIONS), )
	for OPT in $(OPT_OPTIONS) ; do \
	  OD=$(SD)/$$OPT ; \
	  touch $(SD)/m4amr.i; $(RM) $(SD)/m4amr.i ; \
	  if test ! -d  $$OD ; then mkdir $$OD ; fi; \
	  touch $$OD/depends.gnu ; \
	  $(MAKE) $$OD/$(PROGRAM_NAME) PROGRAM_NAME=$(PROGRAM_NAME) \
	    OPT=$$OPT OD=$$OD ; \
	done
else
	for DIST in $(DIST_OPTIONS) ; do \
	  for OPT in $(OPT_OPTIONS) ; do \
	    OD=$(SD)/$$DIST$$OPT ; \
	    touch $(SD)/m4amr.i; $(RM) $(SD)/m4amr.i ; \
	    if test ! -d  $$OD ; then mkdir $$OD ; fi; \
	    touch $$OD/depends.gnu ; \
	    $(MAKE) $$OD/$(PROGRAM_NAME) PROGRAM_NAME=$(PROGRAM_NAME) \
	      OPT=$$OPT DIST=$$DIST OD=$$OD ; \
	  done ; \
	done 
endif
else
ifeq ($(DIST_OPTIONS), )
	for DIM in $(DIM_OPTIONS) ; do \
	  for OPT in $(OPT_OPTIONS) ; do \
	    OD=$(SD)/$$DIM$$OPT ; \
	    touch $(SD)/m4amr.i; $(RM) $(SD)/m4amr.i ; \
	    if test ! -d  $$OD ; then mkdir $$OD ; fi; \
	    touch $$OD/depends.gnu ; \
	    $(MAKE) $$OD/$(PROGRAM_NAME) PROGRAM_NAME=$(PROGRAM_NAME) \
	      OPT=$$OPT DIM=$$DIM OD=$$OD ; \
	  done ; \
	done
else
	for DIM in $(DIM_OPTIONS) ; do \
	  for DIST in $(DIST_OPTIONS) ; do \
	    for OPT in $(OPT_OPTIONS) ; do \
	      OD=$(SD)/$$DIM$$DIST$$OPT ; \
	      touch $(SD)/m4amr.i; $(RM) $(SD)/m4amr.i ; \
	      if test ! -d  $$OD ; then mkdir $$OD ; fi; \
	      touch $$OD/depends.gnu ; \
	      $(MAKE) $$OD/$(PROGRAM_NAME) \
	        PROGRAM_NAME=$(PROGRAM_NAME) OPT=$$OPT DIST=$$DIST \
	        DIM=$$DIM OD=$$OD ; \
	    done ; \
	  done ; \
	done
endif
endif
	
programtest :
	@echo OD = $(OD)
	@echo PROGRAM_DEPENDS = $(PROGRAM_DEPENDS)
	@echo DEBUGFLAGS = $(DEBUGFLAGS)
	@echo OPT = $(OPT)
	@echo DIM = $(DIM)
	@echo CFLAGS = $(CFLAGS)
	@echo ULIBS = $(ULIBS)
	@echo INCLUDE_OPTION = $(INCLUDE_OPTION)

$(OD)/$(PROGRAM_NAME) : $(MAIN) $(OBJECTS)
	$(LINK.C) -o $(OD)/$(PROGRAM_NAME) $(OBJECTS) $(MAIN) \
	  $(ULIBS) $(SLIBS) 
	$(MAKE) depends OD=$(OD)
#ifeq ($(DIST),p)
#ifeq ($(MACHINE),i686)
#	cp $(DET_ODIR)/sync $(OD)
#	cp $(DET_DIR)/cleanup $(OD)
#endif
#endif

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

cleanall :
	for p in $(PROGRAMS) ; do \
	  $(MAKE) cleanprograms PROGRAM_NAME=$$p ; \
	done

cleanprograms :
ifeq ($(DIM_OPTIONS), )
ifeq ($(DIST_OPTIONS), )
	for OPT in $(OPT_OPTIONS) ; do \
	  OD=$(SD)/$$OPT ; \
	  if test ! -d  $$OD ; then mkdir $$OD ; fi; \
	  touch $$OD/depends.gnu ; \
	  $(MAKE) cleanprogram PROGRAM_NAME=$(PROGRAM_NAME) \
	    OPT=$$OPT OD=$(SD)/$$OPT; \
	done
else
	for DIST in $(DIST_OPTIONS) ; do \
	  for OPT in $(OPT_OPTIONS) ; do \
	    OD=$(SD)/$$DIST$$OPT ; \
	    if test ! -d  $$OD ; then mkdir $$OD ; fi; \
	    touch $$OD/depends.gnu ; \
	    $(MAKE) cleanprogram PROGRAM_NAME=$(PROGRAM_NAME) \
	      OPT=$$OPT DIST=$$DIST OD=$(SD)/$$DIST$$OPT; \
	  done ; \
	done
endif
else
ifeq ($(DIST_OPTIONS), )
	for DIM in $(DIM_OPTIONS) ; do \
	  for OPT in $(OPT_OPTIONS) ; do \
	    OD=$(SD)/$$DIM$$OPT ; \
	    if test ! -d  $$OD ; then mkdir $$OD ; fi; \
	    touch $$OD/depends.gnu ; \
	    $(MAKE) cleanprogram PROGRAM_NAME=$(PROGRAM_NAME) \
	      OPT=$$OPT DIM=$$DIM OD=$(SD)/$$DIM$$OPT; \
	  done ; \
	done
else
	for DIM in $(DIM_OPTIONS) ; do \
	  for DIST in $(DIST_OPTIONS) ; do \
	    for OPT in $(OPT_OPTIONS) ; do \
	      OD=$(SD)/$$DIM$$DIST$$OPT ; \
	      if test ! -d  $$OD ; then mkdir $$OD ; fi; \
	      touch $$OD/depends.gnu ; \
	      $(MAKE) cleanprogram PROGRAM_NAME=$(PROGRAM_NAME) \
	        OPT=$$OPT DIST=$$DIST DIM=$$DIM \
		OD=$(SD)/$$DIM$$DIST$$OPT; \
	    done ; \
	  done ; \
	done
endif
endif

cleanprogram :
	rm -f $(OD)/$(PROGRAM_NAME) $(OD)/$(MAIN) $(OBJECTS)

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

nodepends :
ifeq ($(DIM_OPTIONS), )
ifeq ($(DIST_OPTIONS), )
	for OPT in $(OPT_OPTIONS); do \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/depends.gnu ; \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/*.d ; \
	done
else
	for DIST in $(DIST_OPTIONS); do\
	  for OPT in $(OPT_OPTIONS); do \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/depends.gnu ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/*.d ; \
	  done; \
	done
endif
else
ifeq ($(DIST_OPTIONS), )
	for DIM in $(DIM_OPTIONS); do\
	  for OPT in $(OPT_OPTIONS); do \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/depends.gnu ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/*.d ; \
	  done; \
	done
else
	for DIM in $(DIM_OPTIONS); do\
	  for DIST in $(DIST_OPTIONS); do\
	    for OPT in $(OPT_OPTIONS); do \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/depends.gnu ; \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/*.d ; \
	    done; \
	  done; \
	done
endif
endif

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

noplots :
ifeq ($(DIM_OPTIONS), )
ifeq ($(DIST_OPTIONS), )
	for OPT in $(OPT_OPTIONS); do \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.maxmin* ; \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.restart* ; \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.plot* ; \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_plot* ; \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_maxmin* ; \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_restart* ; \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.clog* ; \
	done
else
	for DIST in $(DIST_OPTIONS); do\
	  for OPT in $(OPT_OPTIONS); do \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.maxmin* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.restart* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.plot* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_plot* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_maxmin* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_restart* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.clog* ; \
	  done; \
	done
endif
else
ifeq ($(DIST_OPTIONS), )
	for DIM in $(DIM_OPTIONS); do\
	  for OPT in $(OPT_OPTIONS); do \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.maxmin* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.restart* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.plot* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_plot* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_maxmin* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_restart* ; \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.clog* ; \
	  done; \
	done
else
	for DIM in $(DIM_OPTIONS); do\
	  for DIST in $(DIST_OPTIONS); do\
	    for OPT in $(OPT_OPTIONS); do \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.maxmin* ; \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.restart* ; \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.plot* ; \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_plot* ; \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_maxmin* ; \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.rp_restart* ; \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/cpphog.clog* ; \
	    done; \
	  done; \
	done
endif
endif

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

nolibs :
ifeq ($(DIM_OPTIONS), )
ifeq ($(DIST_OPTIONS), )
	for OPT in $(OPT_OPTIONS); do \
	  rm -f $(SD)/$$DIM$$DIST$$OPT/libamr.$$OPT ; \
	done
else
	for DIST in $(DIST_OPTIONS); do\
	  for OPT in $(OPT_OPTIONS); do \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/libamr.$$OPT ; \
	  done; \
	done
endif
else
ifeq ($(DIST_OPTIONS), )
	for DIM in $(DIM_OPTIONS); do\
	  for OPT in $(OPT_OPTIONS); do \
	    rm -f $(SD)/$$DIM$$DIST$$OPT/libamr.$$OPT ; \
	  done; \
	done
else
	for DIM in $(DIM_OPTIONS); do\
	  for DIST in $(DIST_OPTIONS); do\
	    for OPT in $(OPT_OPTIONS); do \
	      rm -f $(SD)/$$DIM$$DIST$$OPT/libamr.$$OPT ; \
	    done; \
	  done; \
	done
endif
endif

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

ifeq ($(MACHINE),i686)
depends686 :
ifeq ($(DIM_OPTIONS), )
ifeq ($(DIST_OPTIONS), )
	for OPT in $(OPT_OPTIONS); do \
	  $(MAKE) depend686 OPT=$$OPT ; \
	done
else
	for DIST in $(DIST_OPTIONS); do\
	  for OPT in $(OPT_OPTIONS); do \
	    $(MAKE) depend686 DIST=$$DIST OPT=$$OPT ; \
	  done; \
	done
endif
else
ifeq ($(DIST_OPTIONS), )
	for DIM in $(DIM_OPTIONS); do\
	  for OPT in $(OPT_OPTIONS); do \
	    $(MAKE) depend686 DIM=$$DIM OPT=$$OPT ; \
	  done; \
	done
else
	for DIM in $(DIM_OPTIONS); do\
	  for DIST in $(DIST_OPTIONS); do\
	    for OPT in $(OPT_OPTIONS); do \
	      $(MAKE) depend686 DIM=$$DIM DIST=$$DIST OPT=$$OPT ; \
	    done; \
	  done; \
	done
endif
endif

#++++

depend686t :
ifeq ($(DIST),p)
ifneq ($(OPT),a)
	CFL="-E -MMD -DTIMING -DSPACEDIM=$(DIM) -DDISTRIBUTED $(MEMFLAGS) -DDEBUG -DINDEF -DTIMING"
else
	CFL="-E -MMD -DTIMING -DSPACEDIM=$(DIM) -DDISTRIBUTED" $(MEMFLAGS)
endif
else
ifneq ($(OPT),a)
	CFL="-E -MMD -DTIMING -DSPACEDIM=$(DIM) $(MEMFLAGS) -DDEBUG -DINDEF -DTIMING"
else
	CFL="-E -MMD -DTIMING -DSPACEDIM=$(DIM)" $(MEMFLAGS)
endif
endif
	echo processing $(SD)/$(DIM)$(DIST)$(OPT)
	echo CFL = $$CFL

#++++

depend686 :
	@echo processing $(SD)/$(DIM)$(DIST)$(OPT)
ifeq ($(DIST),p)
ifneq ($(OPT),a)
	for p in $(CSOURCES); do \
	  g++ -E -MMD -DTIMING -DSPACEDIM=$(DIM) -DDISTRIBUTED \
	  $(MEMFLAGS) -DDEBUG -DINDEF -DTIMING \
	  $(INCLUDE_OPTION) $$p > /dev/null; \
	done
else
	for p in $(CSOURCES); do \
	  g++ -E -MMD -DTIMING -DSPACEDIM=$(DIM) -DDISTRIBUTED \
	  $(MEMFLAGS) $(INCLUDE_OPTION) $$p > /dev/null; \
	done
endif
else
ifneq ($(OPT),a)
	for p in $(CSOURCES); do \
	  g++ -E -MMD -DTIMING -DSPACEDIM=$(DIM) $(MEMFLAGS) -DDEBUG \
	  -DINDEF -DTIMING $(INCLUDE_OPTION) $$p > /dev/null; \
	done
else
	for p in $(CSOURCES); do \
	  g++ -E -MMD -DTIMING -DSPACEDIM=$(DIM) \
	  $(MEMFLAGS) $(INCLUDE_OPTION) $$p > /dev/null; \
	done
endif
endif
	mv *.d $(SD)/$(DIM)$(DIST)$(OPT)
	-$(RM) $(SD)/$(DIM)$(DIST)$(OPT)/depends.gnu
	cat $(SD)/$(DIM)$(DIST)$(OPT)/*.d > \
	  $(SD)/$(DIM)$(DIST)$(OPT)/depends.gnu
endif

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

release :
	tar --ignore-failed-read -cvf tarfile *.[CHchif] *.m4 \
	  GNUmakefile *.sed sed* *.tex n*
	gzip tarfile
	mv tarfile.gz \
	 /home/system/httpd/cgi-bin/AuthFiles/DukeAMR/$(LIB_BASE).tar.gz
	chmod a+r \
	 /home/system/httpd/cgi-bin/AuthFiles/DukeAMR/$(LIB_BASE).tar.gz

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

ifeq ($(MACHINE),alpha)
$(OD)/m4amr.i : $(MEMDEBUG_DIR)/m4amr.sed
	-chmod u+w $@
	sed -e "s?fvsodir?$(FLOWVAR_DIR)?" $(MEMDEBUG_DIR)/m4amr.sed | \
	sed -e "s?memdebugdir?$(MEMDEBUG_DIR)?" | \
	sed -e "s?logicaltype?logical*1?" | \
	sed -e "s?sodir?$(SD)?" | \
	sed -e "s?sedndim?$(DIM)?" | \
	sed -e "s?seddebug?$(FORT_DEBUG)?" > $@
	-chmod u-w $@
	-$(RM) $(OD)/m4amr.temp
endif
#ifeq ($(MACHINE),i686)
$(OD)/m4amr.i : $(MEMDEBUG_DIR)/m4amr.sed
	-chmod u+w $@
	sed -e "s?fvsodir?$(FLOWVAR_DIR)?" $(MEMDEBUG_DIR)/m4amr.sed | \
	sed -e "s?memdebugdir?$(MEMDEBUG_DIR)?" | \
	sed -e "s?logicaltype?logical*1?" | \
	sed -e "s?sodir?$(SD)?" | \
	sed -e "s?sedndim?$(DIM)?" | \
	sed -e "s?seddebug?$(FORT_DEBUG)?" > $@
	-chmod u-w $@
#endif

$(SD)/m4amr.i : $(OD)/m4amr.i
	-$(RM) $(SD)/m4amr.i
	cp -p $(OD)/m4amr.i $(SD)/m4amr.i

ifneq ($(OD), )
include $(OD)/depends.gnu
endif
