/**********************************************************************\
 * Copyright (c) 2002, Wenjun Ying, Duke University, Math Dept.       *
 *                                                                    *
 *                       ALL RIGHTS RESERVED                          *
 *                                                                    *
 * Permission to use, copy, modify, and distribute this software for  *
 * any purpose and without fee is hereby granted, provided that the   *
 * above copyright notice appear in all copies and that both the      *
 * copyright notice and this permission notice appear in supporting   *
 * documentation, and that the name of Y's MathGL not be used in      *
 * advertising or publicity pertaining to distribution of the         *
 * software without specific, written prior permission.               *
 *                                                                    *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"  *
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,   *
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR   *
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL Y'S MATHGL BE *
 * LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT, SPECIAL, INCIDENTAL,  *
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES      *
 * WHATSOEVER, INCLUDING WITHOUT LIMITATION, LOSS OF PROFIT, LOSS OF  *
 * USE, SAVINGS OR REVENUE, OR THE CLAIMS OF THIRD PARTIES, WHETHER   *
 * OR NOT Y'S MATHGL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH      *
 * LOSS, HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, ARISING OUT   * 
 * OF OR IN CONNECTION WITH THE POSSESSION, USE OR PERFORMANCE OF     *
 * THIS SOFTWARE.                                                     *
 *                                                                    *
\**********************************************************************/

#ifndef __LOOKUP_TABLE_HPP__
#define __LOOKUP_TABLE_HPP__

//#include <iostream>
//#include <stdlib.h>
//#include <math.h>

const int marchingCubesTable[][24]={
  {0,0,0,0,0,0},
  {1,3,0,0,0,0,   8,4,0},
  {2,3,0,0,0,0,   6,8,1},
  {3,4,0,0,0,0,   6,4,0,1},
  {4,3,0,0,0,0,   4,9,2},
  {5,4,0,0,0,0,   8,9,2,0},
  {6,-1,0,2,1,0,0,0,0},
  {7,5,0,0,0,0,   6,9,2,0,1},
  {8,3,0,0,0,0,   9,6,3},
  {9,-1,1,2,1,0,0,0,0},
  {10,4,0,0,0,0,   9,8,1,3},
  {11,5,0,0,0,0,   9,4,0,1,3},
  {12,4,0,0,0,0,   4,6,3,2},
  {13,5,0,0,0,0,   8,6,3,2,0},
  {14,5,0,0,0,0,   4,8,1,3,2},
  {15,4,0,0,0,0,   0,1,3,2},
  {16,3,0,0,0,0,   5,10,0},
  {17,4,0,0,0,0,   8,4,5,10},
  {18,-1,2,1,4,0,0,0,0},
  {19,5,0,0,0,0,   6,4,5,10,1},
  {20,-1,3,4,2,0,0,0,0},
  {21,5,0,0,0,0,   8,9,2,5,10},
  {22,-3,4,2,1,0,1,4,0,4,2,0,0,0,0},
  {23,6,0,0,0,0,   6,9,2,5,10,1},
  {24,3,3,0,0,0,   9,6,3,  5,10,0},
  {25,-1,8,2,1,0,0,0,0},
  {26,-1,9,1,4,0,0,0,0},
  {27,6,0,0,0,0,   9,4,5,10,1,3},
  {28,-1,10,4,2,0,0,0,0},
  {29,6,0,0,0,0,   8,6,3,2,5,10},
  {30,-2,11,1,4,0,4,2,0,0,0,0},
  {31,5,0,0,0,0,   5,10,1,3,2},
  {32,3,0,0,0,0,   10,7,1},
  {33,-1,13,1,4,0,0,0,0},
  {34,4,0,0,0,0,   6,8,10,7},
  {35,5,0,0,0,0,   6,4,0,10,7},
  {36,3,3,0,0,0,   4,9,2,  10,7,1},
  {37,-1,14,1,4,0,0,0,0},
  {38,-1,15,2,1,0,0,0,0},
  {39,6,0,0,0,0,   6,9,2,0,10,7},
  {40,-1,16,5,3,1,0,0,0},
  {41,-3,17,2,1,0,1,4,0,5,3,1,0,0,0},
  {42,5,0,0,0,0,   9,8,10,7,3},
  {43,6,0,0,0,0,   9,4,0,10,7,3},
  {44,-1,21,5,3,1,0,0,0},
  {45,-2,22,1,4,0,5,3,1,0,0,0},
  {46,6,0,0,0,0,   4,8,10,7,3,2},
  {47,5,0,0,0,0,   10,7,3,2,0},
  {48,4,0,0,0,0,   5,7,1,0},
  {49,5,0,0,0,0,   8,4,5,7,1},
  {50,5,0,0,0,0,   6,8,0,5,7},
  {51,4,0,0,0,0,   6,4,5,7},
  {52,-1,24,4,2,0,0,0,0},
  {53,6,0,0,0,0,   8,9,2,5,7,1},
  {54,-2,25,2,1,0,4,2,0,0,0,0},
  {55,5,0,0,0,0,   6,9,2,5,7},
  {56,-1,27,5,3,1,0,0,0},
  {57,-2,28,2,1,0,5,3,1,0,0,0},
  {58,6,0,0,0,0,   9,8,0,5,7,3},
  {59,5,0,0,0,0,   9,4,5,7,3},
  {60,-2,30,4,2,0,5,3,1,0,0,0},
  {61,-1,32,5,3,1,0,0,0},
  {62,-1,33,4,2,0,0,0,0},
  {63,4,0,0,0,0,   5,7,3,2},
  {64,3,0,0,0,0,   11,5,2},
  {65,-1,34,4,2,0,0,0,0},
  {66,3,3,0,0,0,   6,8,1,  11,5,2},
  {67,-1,35,4,2,0,0,0,0},
  {68,4,0,0,0,0,   4,9,11,5},
  {69,5,0,0,0,0,   8,9,11,5,0},
  {70,-1,36,2,1,0,0,0,0},
  {71,6,0,0,0,0,   6,9,11,5,0,1},
  {72,-1,37,3,6,2,0,0,0},
  {73,-3,38,2,1,0,3,6,2,4,2,0,0,0,0},
  {74,-1,42,3,6,2,0,0,0},
  {75,-2,43,3,6,2,4,2,0,0,0,0},
  {76,5,0,0,0,0,   4,6,3,11,5},
  {77,6,0,0,0,0,   8,6,3,11,5,0},
  {78,6,0,0,0,0,   4,8,1,3,11,5},
  {79,5,0,0,0,0,   11,5,0,1,3},
  {80,4,0,0,0,0,   11,10,0,2},
  {81,5,0,0,0,0,   8,4,2,11,10},
  {82,-1,45,1,4,0,0,0,0},
  {83,6,0,0,0,0,   6,4,2,11,10,1},
  {84,5,0,0,0,0,   4,9,11,10,0},
  {85,4,0,0,0,0,   8,9,11,10},
  {86,-2,46,2,1,0,1,4,0,0,0,0},
  {87,5,0,0,0,0,   6,9,11,10,1},
  {88,-1,48,3,6,2,0,0,0},
  {89,-2,49,2,1,0,3,6,2,0,0,0},
  {90,-2,51,1,4,0,3,6,2,0,0,0},
  {91,-1,53,3,6,2,0,0,0},
  {92,6,0,0,0,0,   4,6,3,11,10,0},
  {93,5,0,0,0,0,   8,6,3,11,10},
  {94,-1,54,1,4,0,0,0,0},
  {95,4,0,0,0,0,   11,10,1,3},
  {96,-1,55,6,5,4,0,0,0},
  {97,-3,56,6,5,4,1,4,0,4,2,0,0,0,0},
  {98,-1,60,6,5,4,0,0,0},
  {99,-2,61,6,5,4,4,2,0,0,0,0},
  {100,-1,63,6,5,4,0,0,0},
  {101,-2,64,6,5,4,1,4,0,0,0,0},
  {102,-2,66,2,1,0,6,5,4,0,0,0},
  {103,-1,68,6,5,4,0,0,0},
  {104,-3,69,6,5,4,3,6,2,5,3,1,0,0,0},
  {105,-6,73,2,1,0,6,5,4,1,4,0,3,6,2,4,2,0,5,3,1,0,0,0},
  {106,-2,105,6,5,4,3,6,2,0,0,0},
  {107,-3,107,6,5,4,3,6,2,4,2,0,0,0,0},
  {108,-2,111,6,5,4,5,3,1,0,0,0},
  {109,-3,113,6,5,4,1,4,0,5,3,1,0,0,0},
  {110,-1,117,6,5,4,0,0,0},
  {111,-1,118,6,5,4,0,0,0},
  {112,5,0,0,0,0,   11,7,1,0,2},
  {113,6,0,0,0,0,   8,4,2,11,7,1},
  {114,6,0,0,0,0,   6,8,0,2,11,7},
  {115,5,0,0,0,0,   6,4,2,11,7},
  {116,6,0,0,0,0,   4,9,11,7,1,0},
  {117,5,0,0,0,0,   8,9,11,7,1},
  {118,-1,119,2,1,0,0,0,0},
  {119,4,0,0,0,0,   6,9,11,7},
  {120,-2,120,3,6,2,5,3,1,0,0,0},
  {121,-3,122,2,1,0,3,6,2,5,3,1,0,0,0},
  {122,-1,126,3,6,2,0,0,0},
  {123,-1,127,3,6,2,0,0,0},
  {124,-1,128,5,3,1,0,0,0},
  {125,-1,129,5,3,1,0,0,0},
  {126,3,3,0,0,0,   4,8,0,  11,7,3},
  {127,3,0,0,0,0,   11,7,3},
  {128,3,0,0,0,0,   7,11,3},
  {129,3,3,0,0,0,   8,4,0,  7,11,3},
  {130,-1,130,5,3,1,0,0,0},
  {131,-1,131,5,3,1,0,0,0},
  {132,-1,132,3,6,2,0,0,0},
  {133,-1,133,3,6,2,0,0,0},
  {134,-3,134,2,1,0,3,6,2,5,3,1,0,0,0},
  {135,-2,138,3,6,2,5,3,1,0,0,0},
  {136,4,0,0,0,0,   9,6,7,11},
  {137,-1,140,2,1,0,0,0,0},
  {138,5,0,0,0,0,   9,8,1,7,11},
  {139,6,0,0,0,0,   9,4,0,1,7,11},
  {140,5,0,0,0,0,   4,6,7,11,2},
  {141,6,0,0,0,0,   8,6,7,11,2,0},
  {142,6,0,0,0,0,   4,8,1,7,11,2},
  {143,5,0,0,0,0,   7,11,2,0,1},
  {144,-1,141,6,5,4,0,0,0},
  {145,-1,142,6,5,4,0,0,0},
  {146,-3,143,6,5,4,1,4,0,5,3,1,0,0,0},
  {147,-2,147,6,5,4,5,3,1,0,0,0},
  {148,-3,149,6,5,4,3,6,2,4,2,0,0,0,0},
  {149,-2,153,6,5,4,3,6,2,0,0,0},
  {150,-6,155,2,1,0,6,5,4,1,4,0,3,6,2,4,2,0,5,3,1,0,0,0},
  {151,-3,187,6,5,4,3,6,2,5,3,1,0,0,0},
  {152,-1,191,6,5,4,0,0,0},
  {153,-2,192,2,1,0,6,5,4,0,0,0},
  {154,-2,194,6,5,4,1,4,0,0,0,0},
  {155,-1,196,6,5,4,0,0,0},
  {156,-2,197,6,5,4,4,2,0,0,0,0},
  {157,-1,199,6,5,4,0,0,0},
  {158,-3,200,6,5,4,1,4,0,4,2,0,0,0,0},
  {159,-1,204,6,5,4,0,0,0},
  {160,4,0,0,0,0,   10,11,3,1},
  {161,-1,205,1,4,0,0,0,0},
  {162,5,0,0,0,0,   6,8,10,11,3},
  {163,6,0,0,0,0,   6,4,0,10,11,3},
  {164,-1,206,3,6,2,0,0,0},
  {165,-2,207,1,4,0,3,6,2,0,0,0},
  {166,-2,209,2,1,0,3,6,2,0,0,0},
  {167,-1,211,3,6,2,0,0,0},
  {168,5,0,0,0,0,   9,6,1,10,11},
  {169,-2,212,2,1,0,1,4,0,0,0,0},
  {170,4,0,0,0,0,   9,8,10,11},
  {171,5,0,0,0,0,   9,4,0,10,11},
  {172,6,0,0,0,0,   4,6,1,10,11,2},
  {173,-1,214,1,4,0,0,0,0},
  {174,5,0,0,0,0,   4,8,10,11,2},
  {175,4,0,0,0,0,   10,11,2,0},
  {176,5,0,0,0,0,   5,11,3,1,0},
  {177,6,0,0,0,0,   8,4,5,11,3,1},
  {178,6,0,0,0,0,   6,8,0,5,11,3},
  {179,5,0,0,0,0,   6,4,5,11,3},
  {180,-2,215,3,6,2,4,2,0,0,0,0},
  {181,-1,217,3,6,2,0,0,0},
  {182,-3,218,2,1,0,3,6,2,4,2,0,0,0,0},
  {183,-1,222,3,6,2,0,0,0},
  {184,6,0,0,0,0,   9,6,1,0,5,11},
  {185,-1,223,2,1,0,0,0,0},
  {186,5,0,0,0,0,   9,8,0,5,11},
  {187,4,0,0,0,0,   9,4,5,11},
  {188,-1,224,4,2,0,0,0,0},
  {189,3,3,0,0,0,   8,6,1,  5,11,2},
  {190,-1,225,4,2,0,0,0,0},
  {191,3,0,0,0,0,   5,11,2},
  {192,4,0,0,0,0,   7,5,2,3},
  {193,-1,226,4,2,0,0,0,0},
  {194,-1,227,5,3,1,0,0,0},
  {195,-2,228,4,2,0,5,3,1,0,0,0},
  {196,5,0,0,0,0,   4,9,3,7,5},
  {197,6,0,0,0,0,   8,9,3,7,5,0},
  {198,-2,230,2,1,0,5,3,1,0,0,0},
  {199,-1,232,5,3,1,0,0,0},
  {200,5,0,0,0,0,   9,6,7,5,2},
  {201,-2,233,2,1,0,4,2,0,0,0,0},
  {202,6,0,0,0,0,   9,8,1,7,5,2},
  {203,-1,235,4,2,0,0,0,0},
  {204,4,0,0,0,0,   4,6,7,5},
  {205,5,0,0,0,0,   8,6,7,5,0},
  {206,5,0,0,0,0,   4,8,1,7,5},
  {207,4,0,0,0,0,   7,5,0,1},
  {208,5,0,0,0,0,   7,10,0,2,3},
  {209,6,0,0,0,0,   8,4,2,3,7,10},
  {210,-2,236,1,4,0,5,3,1,0,0,0},
  {211,-1,238,5,3,1,0,0,0},
  {212,6,0,0,0,0,   4,9,3,7,10,0},
  {213,5,0,0,0,0,   8,9,3,7,10},
  {214,-3,239,2,1,0,1,4,0,5,3,1,0,0,0},
  {215,-1,243,5,3,1,0,0,0},
  {216,6,0,0,0,0,   9,6,7,10,0,2},
  {217,-1,244,2,1,0,0,0,0},
  {218,-1,245,1,4,0,0,0,0},
  {219,3,3,0,0,0,   9,4,2,  7,10,1},
  {220,5,0,0,0,0,   4,6,7,10,0},
  {221,4,0,0,0,0,   8,6,7,10},
  {222,-1,246,1,4,0,0,0,0},
  {223,3,0,0,0,0,   7,10,1},
  {224,5,0,0,0,0,   10,5,2,3,1},
  {225,-2,247,1,4,0,4,2,0,0,0,0},
  {226,6,0,0,0,0,   6,8,10,5,2,3},
  {227,-1,249,4,2,0,0,0,0},
  {228,6,0,0,0,0,   4,9,3,1,10,5},
  {229,-1,250,1,4,0,0,0,0},
  {230,-1,251,2,1,0,0,0,0},
  {231,3,3,0,0,0,   6,9,3,  10,5,0},
  {232,6,0,0,0,0,   9,6,1,10,5,2},
  {233,-3,252,2,1,0,1,4,0,4,2,0,0,0,0},
  {234,5,0,0,0,0,   9,8,10,5,2},
  {235,-1,256,4,2,0,0,0,0},
  {236,5,0,0,0,0,   4,6,1,10,5},
  {237,-1,257,1,4,0,0,0,0},
  {238,4,0,0,0,0,   4,8,10,5},
  {239,3,0,0,0,0,   10,5,0},
  {240,4,0,0,0,0,   1,0,2,3},
  {241,5,0,0,0,0,   8,4,2,3,1},
  {242,5,0,0,0,0,   6,8,0,2,3},
  {243,4,0,0,0,0,   6,4,2,3},
  {244,5,0,0,0,0,   4,9,3,1,0},
  {245,4,0,0,0,0,   8,9,3,1},
  {246,-1,258,2,1,0,0,0,0},
  {247,3,0,0,0,0,   6,9,3},
  {248,5,0,0,0,0,   9,6,1,0,2},
  {249,-1,259,2,1,0,0,0,0},
  {250,4,0,0,0,0,   9,8,0,2},
  {251,3,0,0,0,0,   9,4,2},
  {252,4,0,0,0,0,   4,6,1,0},
  {253,3,0,0,0,0,   8,6,1},
  {254,3,0,0,0,0,   4,8,0},
  {255,0,0,0,0,0}
};

const int marchingCubesSubTable[][32]={
  {6,3,3,0,0,0,   8,1,6,  9,2,4},
  {6,6,0,0,0,0,   8,1,6,9,2,4},
  {9,6,0,0,0,0,   0,8,6,3,9,4},
  {9,3,3,0,0,0,   0,8,4,  3,9,6},
  {18,3,3,0,0,0,   6,8,1,  5,10,0},
  {18,6,0,0,0,0,   6,8,0,5,10,1},
  {20,3,3,0,0,0,   4,9,2,  5,10,0},
  {20,6,0,0,0,0,   4,9,2,5,10,0},
  {22,3,3,3,0,0,   5,10,0,  9,2,4,  1,6,8},
  {22,6,3,0,0,0,   5,10,0,4,9,2,  1,6,8},
  {22,6,3,0,0,0,   5,10,1,6,8,0,  9,2,4},
  {22,9,0,0,0,0,   5,10,1,6,8,0,4,9,2},
  {22,3,6,0,0,0,   5,10,0,  9,2,4,8,1,6},
  {22,9,0,0,0,0,   5,10,0,4,8,1,6,9,2},
  {22,9,0,0,0,0,   5,10,1,6,9,2,4,8,0},
  {22,6,3,0,0,0,   5,10,1,6,9,2,  4,8,0},
  {25,7,0,0,0,0,   5,10,8,6,3,9,4},
  {25,4,3,0,0,0,   5,10,8,4,  3,9,6},
  {26,4,3,0,0,0,   9,8,1,3,  5,10,0},
  {26,7,0,0,0,0,   9,8,0,5,10,1,3},
  {28,4,3,0,0,0,   4,6,3,2,  5,10,0},
  {28,7,0,0,0,0,   4,6,3,2,5,10,0},
  {30,5,3,0,0,0,   4,8,1,3,2,  5,10,0},
  {30,8,0,0,0,0,   4,8,1,3,2,5,10,0},
  {30,8,0,0,0,0,   4,8,0,5,10,1,3,2},
  {30,3,5,0,0,0,   4,8,0,  5,10,1,3,2},
  {33,6,0,0,0,0,   8,4,0,10,7,1},
  {33,3,3,0,0,0,   8,4,0,  10,7,1},
  {37,7,0,0,0,0,   8,9,2,0,10,7,1},
  {37,4,3,0,0,0,   8,9,2,0,  10,7,1},
  {38,4,3,0,0,0,   10,7,6,8,  9,2,4},
  {38,7,0,0,0,0,   10,7,6,9,2,4,8},
  {40,3,3,0,0,0,   9,6,3,  10,7,1},
  {40,6,0,0,0,0,   9,6,1,10,7,3},
  {41,9,0,0,0,0,   10,7,1,8,6,3,9,4,0},
  {41,6,3,0,0,0,   10,7,3,9,4,0,  8,6,1},
  {41,3,6,0,0,0,   10,7,1,  3,9,4,0,8,6},
  {41,9,0,0,0,0,   10,7,3,9,4,0,8,6,1},
  {41,6,3,0,0,0,   10,7,1,8,4,0,  3,9,6},
  {41,9,0,0,0,0,   10,7,3,9,6,1,8,4,0},
  {41,3,3,3,0,0,   10,7,1,  3,9,6,  4,0,8},
  {41,6,3,0,0,0,   10,7,3,9,6,1,  4,0,8},
  {44,4,3,0,0,0,   4,6,3,2,  10,7,1},
  {44,7,0,0,0,0,   4,6,1,10,7,3,2},
  {45,8,0,0,0,0,   8,6,3,2,0,10,7,1},
  {45,3,5,0,0,0,   8,6,1,  10,7,3,2,0},
  {45,5,3,0,0,0,   8,6,3,2,0,  10,7,1},
  {45,8,0,0,0,0,   8,6,1,10,7,3,2,0},
  {52,3,4,0,0,0,   4,9,2,  5,7,1,0},
  {52,7,0,0,0,0,   4,9,2,5,7,1,0},
  {54,5,3,0,0,0,   5,7,6,8,0,  9,2,4},
  {54,8,0,0,0,0,   5,7,6,8,0,4,9,2},
  {54,8,0,0,0,0,   5,7,6,9,2,4,8,0},
  {54,5,3,0,0,0,   5,7,6,9,2,  8,0,4},
  {56,3,4,0,0,0,   9,6,3,  5,7,1,0},
  {56,7,0,0,0,0,   9,6,1,0,5,7,3},
  {57,8,0,0,0,0,   5,7,1,8,6,3,9,4},
  {57,5,3,0,0,0,   5,7,3,9,4,  1,8,6},
  {57,5,3,0,0,0,   5,7,1,8,4,  3,9,6},
  {57,8,0,0,0,0,   5,7,3,9,6,1,8,4},
  {60,4,4,0,0,0,   4,6,3,2,  5,7,1,0},
  {60,8,0,0,0,0,   4,6,1,0,5,7,3,2},
  {60,8,0,0,0,0,   4,6,3,2,5,7,1,0},
  {60,4,4,0,0,0,   4,6,1,0,  5,7,3,2},
  {61,7,0,0,0,0,   8,6,3,2,5,7,1},
  {61,3,4,0,0,0,   8,6,1,  5,7,3,2},
  {62,7,0,0,0,0,   4,8,0,5,7,3,2},
  {62,3,4,0,0,0,   4,8,0,  5,7,3,2},
  {65,6,0,0,0,0,   8,4,2,11,5,0},
  {65,3,3,0,0,0,   8,4,0,  11,5,2},
  {67,7,0,0,0,0,   6,4,2,11,5,0,1},
  {67,4,3,0,0,0,   6,4,0,1,  11,5,2},
  {70,4,3,0,0,0,   11,5,4,9,  8,1,6},
  {70,7,0,0,0,0,   11,5,4,8,1,6,9},
  {72,3,3,0,0,0,   9,6,3,  11,5,2},
  {72,6,0,0,0,0,   9,6,3,11,5,2},
  {73,9,0,0,0,0,   11,5,0,8,6,3,9,4,2},
  {73,3,6,0,0,0,   11,5,2,  0,8,6,3,9,4},
  {73,6,3,0,0,0,   11,5,0,8,6,3,  9,4,2},
  {73,9,0,0,0,0,   11,5,2,9,4,0,8,6,3},
  {73,6,3,0,0,0,   11,5,0,8,4,2,  6,3,9},
  {73,3,3,3,0,0,   11,5,2,  0,8,4,  6,3,9},
  {73,9,0,0,0,0,   11,5,0,8,4,2,9,6,3},
  {73,6,3,0,0,0,   11,5,2,9,6,3,  0,8,4},
  {74,4,3,0,0,0,   9,8,1,3,  11,5,2},
  {74,7,0,0,0,0,   9,8,1,3,11,5,2},
  {75,8,0,0,0,0,   9,4,2,11,5,0,1,3},
  {75,5,3,0,0,0,   9,4,0,1,3,  11,5,2},
  {75,3,5,0,0,0,   9,4,2,  11,5,0,1,3},
  {75,8,0,0,0,0,   9,4,0,1,3,11,5,2},
  {82,3,4,0,0,0,   6,8,1,  11,10,0,2},
  {82,7,0,0,0,0,   6,8,0,2,11,10,1},
  {86,5,3,0,0,0,   11,10,0,4,9,  1,6,8},
  {86,8,0,0,0,0,   11,10,1,6,8,0,4,9},
  {86,8,0,0,0,0,   11,10,0,4,8,1,6,9},
  {86,5,3,0,0,0,   11,10,1,6,9,  0,4,8},
  {88,3,4,0,0,0,   9,6,3,  11,10,0,2},
  {88,7,0,0,0,0,   9,6,3,11,10,0,2},
  {89,8,0,0,0,0,   11,10,8,6,3,9,4,2},
  {89,5,3,0,0,0,   11,10,8,6,3,  4,2,9},
  {89,5,3,0,0,0,   11,10,8,4,2,  6,3,9},
  {89,8,0,0,0,0,   11,10,8,4,2,9,6,3},
  {90,4,4,0,0,0,   9,8,1,3,  11,10,0,2},
  {90,8,0,0,0,0,   9,8,1,3,11,10,0,2},
  {90,8,0,0,0,0,   9,8,0,2,11,10,1,3},
  {90,4,4,0,0,0,   9,8,0,2,  11,10,1,3},
  {91,7,0,0,0,0,   9,4,2,11,10,1,3},
  {91,3,4,0,0,0,   9,4,2,  11,10,1,3},
  {94,7,0,0,0,0,   4,8,1,3,11,10,0},
  {94,3,4,0,0,0,   4,8,0,  11,10,1,3},
  {96,3,3,0,0,0,   1,10,7,  2,11,5},
  {96,6,0,0,0,0,   1,10,5,2,11,7},
  {97,9,0,0,0,0,   8,4,2,11,5,0,10,7,1},
  {97,6,3,0,0,0,   8,4,0,10,7,1,  2,11,5},
  {97,6,3,0,0,0,   8,4,2,11,5,0,  7,1,10},
  {97,3,3,3,0,0,   8,4,0,  2,11,5,  7,1,10},
  {97,6,3,0,0,0,   8,4,2,11,7,1,  10,5,0},
  {97,9,0,0,0,0,   8,4,0,10,5,2,11,7,1},
  {97,9,0,0,0,0,   8,4,2,11,7,1,10,5,0},
  {97,3,6,0,0,0,   8,4,0,  2,11,7,1,10,5},
  {98,4,3,0,0,0,   6,8,10,7,  2,11,5},
  {98,7,0,0,0,0,   6,8,10,5,2,11,7},
  {99,8,0,0,0,0,   6,4,2,11,5,0,10,7},
  {99,5,3,0,0,0,   6,4,0,10,7,  2,11,5},
  {99,5,3,0,0,0,   6,4,2,11,7,  0,10,5},
  {99,8,0,0,0,0,   6,4,0,10,5,2,11,7},
  {100,4,3,0,0,0,   4,9,11,5,  1,10,7},
  {100,7,0,0,0,0,   4,9,11,7,1,10,5},
  {101,8,0,0,0,0,   8,9,11,5,0,10,7,1},
  {101,5,3,0,0,0,   8,9,11,5,0,  7,1,10},
  {101,5,3,0,0,0,   8,9,11,7,1,  5,0,10},
  {101,8,0,0,0,0,   8,9,11,7,1,10,5,0},
  {102,4,4,0,0,0,   8,10,7,6,  9,11,5,4},
  {102,8,0,0,0,0,   8,10,5,4,9,11,7,6},
  {102,8,0,0,0,0,   8,10,7,6,9,11,5,4},
  {102,4,4,0,0,0,   8,10,5,4,  9,11,7,6},
  {103,7,0,0,0,0,   6,9,11,5,0,10,7},
  {103,4,3,0,0,0,   6,9,11,7,  0,10,5},
  {104,3,3,3,0,0,   9,6,3,  1,10,7,  5,2,11},
  {104,6,3,0,0,0,   9,6,1,10,7,3,  5,2,11},
  {104,6,3,0,0,0,   9,6,3,11,5,2,  1,10,7},
  {104,9,0,0,0,0,   9,6,1,10,7,3,11,5,2},
  {104,3,6,0,0,0,   9,6,3,  1,10,5,2,11,7},
  {104,9,0,0,0,0,   9,6,1,10,5,2,11,7,3},
  {104,9,0,0,0,0,   9,6,3,11,7,1,10,5,2},
  {104,6,3,0,0,0,   9,6,1,10,5,2,  11,7,3},
  {105,12,0,0,0,0,   9,4,2,11,5,0,10,7,1,8,6,3},
  {105,9,3,0,0,0,   9,4,2,11,5,0,10,7,3,  8,6,1},
  {105,9,3,0,0,0,   9,4,0,10,7,1,8,6,3,  11,5,2},
  {105,6,3,3,0,0,   9,4,0,10,7,3,  8,6,1,  11,5,2},
  {105,3,9,0,0,0,   9,4,2,  8,6,3,11,5,0,10,7,1},
  {105,3,3,6,0,0,   9,4,2,  8,6,1,  11,5,0,10,7,3},
  {105,12,0,0,0,0,   9,4,0,10,7,1,8,6,3,11,5,2},
  {105,9,3,0,0,0,   9,4,0,10,7,3,11,5,2,  8,6,1},
  {105,9,3,0,0,0,   9,4,2,11,5,0,8,6,3,  10,7,1},
  {105,12,0,0,0,0,   9,4,2,11,5,0,8,6,1,10,7,3},
  {105,6,3,3,0,0,   9,4,0,8,6,3,  11,5,2,  10,7,1},
  {105,9,3,0,0,0,   9,4,0,8,6,1,10,7,3,  11,5,2},
  {105,3,6,3,0,0,   9,4,2,  8,6,3,11,5,0,  10,7,1},
  {105,3,9,0,0,0,   9,4,2,  8,6,1,10,7,3,11,5,0},
  {105,9,3,0,0,0,   9,4,0,8,6,3,11,5,2,  10,7,1},
  {105,12,0,0,0,0,   9,4,0,8,6,1,10,7,3,11,5,2},
  {105,9,3,0,0,0,   9,4,2,11,7,1,8,6,3,  10,5,0},
  {105,6,3,3,0,0,   9,4,2,11,7,3,  8,6,1,  10,5,0},
  {105,12,0,0,0,0,   9,4,0,10,5,2,11,7,1,8,6,3},
  {105,9,3,0,0,0,   9,4,0,10,5,2,11,7,3,  8,6,1},
  {105,3,6,3,0,0,   9,4,2,  8,6,3,11,7,1,  10,5,0},
  {105,3,3,3,3,0,   9,4,2,  8,6,1,  10,5,0,  11,7,3},
  {105,6,6,0,0,0,   9,4,0,10,5,2,  8,6,3,11,7,1},
  {105,6,3,3,0,0,   9,4,0,10,5,2,  8,6,1,  11,7,3},
  {105,12,0,0,0,0,   9,4,2,11,7,1,10,5,0,8,6,3},
  {105,6,6,0,0,0,   9,4,2,11,7,3,  8,6,1,10,5,0},
  {105,6,6,0,0,0,   9,4,0,8,6,3,  10,5,2,11,7,1},
  {105,12,0,0,0,0,   9,4,0,8,6,1,10,5,2,11,7,3},
  {105,3,9,0,0,0,   9,4,2,  8,6,3,11,7,1,10,5,0},
  {105,3,6,3,0,0,   9,4,2,  8,6,1,10,5,0,  11,7,3},
  {105,12,0,0,0,0,   9,4,0,8,6,3,11,7,1,10,5,2},
  {105,9,3,0,0,0,   9,4,0,8,6,1,10,5,2,  11,7,3},
  {105,9,3,0,0,0,   8,4,2,11,5,0,10,7,1,  9,6,3},
  {105,12,0,0,0,0,   8,4,2,11,5,0,10,7,3,9,6,1},
  {105,6,3,3,0,0,   8,4,0,10,7,1,  9,6,3,  11,5,2},
  {105,9,3,0,0,0,   8,4,0,10,7,3,9,6,1,  11,5,2},
  {105,12,0,0,0,0,   8,4,2,9,6,3,11,5,0,10,7,1},
  {105,6,6,0,0,0,   8,4,2,9,6,1,  11,5,0,10,7,3},
  {105,6,6,0,0,0,   8,4,0,10,7,1,  9,6,3,11,5,2},
  {105,12,0,0,0,0,   8,4,0,10,7,3,11,5,2,9,6,1},
  {105,6,3,3,0,0,   8,4,2,11,5,0,  9,6,3,  10,7,1},
  {105,6,6,0,0,0,   8,4,2,11,5,0,  9,6,1,10,7,3},
  {105,3,3,3,3,0,   8,4,0,  9,6,3,  11,5,2,  10,7,1},
  {105,3,6,3,0,0,   8,4,0,  9,6,1,10,7,3,  11,5,2},
  {105,9,3,0,0,0,   8,4,2,9,6,3,11,5,0,  10,7,1},
  {105,12,0,0,0,0,   8,4,2,9,6,1,10,7,3,11,5,0},
  {105,3,6,3,0,0,   8,4,0,  9,6,3,11,5,2,  10,7,1},
  {105,3,9,0,0,0,   8,4,0,  9,6,1,10,7,3,11,5,2},
  {105,6,3,3,0,0,   8,4,2,11,7,1,  9,6,3,  10,5,0},
  {105,9,3,0,0,0,   8,4,2,11,7,3,9,6,1,  10,5,0},
  {105,9,3,0,0,0,   8,4,0,10,5,2,11,7,1,  9,6,3},
  {105,12,0,0,0,0,   8,4,0,10,5,2,11,7,3,9,6,1},
  {105,9,3,0,0,0,   8,4,2,9,6,3,11,7,1,  10,5,0},
  {105,6,3,3,0,0,   8,4,2,9,6,1,  10,5,0,  11,7,3},
  {105,12,0,0,0,0,   8,4,0,10,5,2,9,6,3,11,7,1},
  {105,9,3,0,0,0,   8,4,0,10,5,2,9,6,1,  11,7,3},
  {105,9,3,0,0,0,   8,4,2,11,7,1,10,5,0,  9,6,3},
  {105,12,0,0,0,0,   8,4,2,11,7,3,9,6,1,10,5,0},
  {105,3,3,6,0,0,   8,4,0,  9,6,3,  10,5,2,11,7,1},
  {105,3,9,0,0,0,   8,4,0,  9,6,1,10,5,2,11,7,3},
  {105,12,0,0,0,0,   8,4,2,9,6,3,11,7,1,10,5,0},
  {105,9,3,0,0,0,   8,4,2,9,6,1,10,5,0,  11,7,3},
  {105,3,9,0,0,0,   8,4,0,  9,6,3,11,7,1,10,5,2},
  {105,3,6,3,0,0,   8,4,0,  9,6,1,10,5,2,  11,7,3},
  {106,5,3,0,0,0,   9,8,10,7,3,  5,2,11},
  {106,8,0,0,0,0,   9,8,10,7,3,11,5,2},
  {106,8,0,0,0,0,   9,8,10,5,2,11,7,3},
  {106,5,3,0,0,0,   9,8,10,5,2,  7,3,11},
  {107,9,0,0,0,0,   9,4,2,11,5,0,10,7,3},
  {107,6,3,0,0,0,   9,4,0,10,7,3,  11,5,2},
  {107,3,6,0,0,0,   9,4,2,  0,10,7,3,11,5},
  {107,9,0,0,0,0,   9,4,0,10,7,3,11,5,2},
  {107,6,3,0,0,0,   9,4,2,11,7,3,  0,10,5},
  {107,9,0,0,0,0,   9,4,0,10,5,2,11,7,3},
  {107,3,3,3,0,0,   9,4,2,  0,10,5,  7,3,11},
  {107,6,3,0,0,0,   9,4,0,10,5,2,  7,3,11},
  {108,5,3,0,0,0,   4,6,3,11,5,  1,10,7},
  {108,8,0,0,0,0,   4,6,1,10,7,3,11,5},
  {108,8,0,0,0,0,   4,6,3,11,7,1,10,5},
  {108,5,3,0,0,0,   4,6,1,10,5,  3,11,7},
  {109,9,0,0,0,0,   8,6,3,11,5,0,10,7,1},
  {109,3,6,0,0,0,   8,6,1,  3,11,5,0,10,7},
  {109,6,3,0,0,0,   8,6,3,11,5,0,  10,7,1},
  {109,9,0,0,0,0,   8,6,1,10,7,3,11,5,0},
  {109,6,3,0,0,0,   8,6,3,11,7,1,  5,0,10},
  {109,3,3,3,0,0,   8,6,1,  3,11,7,  5,0,10},
  {109,9,0,0,0,0,   8,6,3,11,7,1,10,5,0},
  {109,6,3,0,0,0,   8,6,1,10,5,0,  3,11,7},
  {110,7,0,0,0,0,   4,8,10,7,3,11,5},
  {110,4,3,0,0,0,   4,8,10,5,  3,11,7},
  {111,6,0,0,0,0,   0,10,7,3,11,5},
  {111,3,3,0,0,0,   0,10,5,  3,11,7},
  {118,7,0,0,0,0,   11,7,6,8,0,4,9},
  {118,4,3,0,0,0,   11,7,6,9,  8,0,4},
  {120,3,5,0,0,0,   9,6,3,  11,7,1,0,2},
  {120,8,0,0,0,0,   9,6,1,0,2,11,7,3},
  {120,8,0,0,0,0,   9,6,3,11,7,1,0,2},
  {120,5,3,0,0,0,   9,6,1,0,2,  11,7,3},
  {121,9,0,0,0,0,   11,7,1,8,6,3,9,4,2},
  {121,6,3,0,0,0,   11,7,3,9,4,2,  1,8,6},
  {121,6,3,0,0,0,   11,7,1,8,6,3,  4,2,9},
  {121,3,3,3,0,0,   11,7,3,  1,8,6,  4,2,9},
  {121,6,3,0,0,0,   11,7,1,8,4,2,  9,6,3},
  {121,9,0,0,0,0,   11,7,3,9,6,1,8,4,2},
  {121,9,0,0,0,0,   11,7,1,8,4,2,9,6,3},
  {121,3,6,0,0,0,   11,7,3,  1,8,4,2,9,6},
  {122,7,0,0,0,0,   9,8,0,2,11,7,3},
  {122,4,3,0,0,0,   9,8,0,2,  11,7,3},
  {123,6,0,0,0,0,   9,4,2,11,7,3},
  {123,3,3,0,0,0,   9,4,2,  11,7,3},
  {124,7,0,0,0,0,   4,6,3,11,7,1,0},
  {124,4,3,0,0,0,   4,6,1,0,  11,7,3},
  {125,6,0,0,0,0,   8,6,3,11,7,1},
  {125,3,3,0,0,0,   8,6,1,  11,7,3},
  {130,6,0,0,0,0,   6,8,1,7,11,3},
  {130,3,3,0,0,0,   6,8,1,  7,11,3},
  {131,7,0,0,0,0,   6,4,0,1,7,11,3},
  {131,4,3,0,0,0,   6,4,0,1,  7,11,3},
  {132,6,0,0,0,0,   4,9,3,7,11,2},
  {132,3,3,0,0,0,   4,9,2,  7,11,3},
  {133,7,0,0,0,0,   8,9,3,7,11,2,0},
  {133,4,3,0,0,0,   8,9,2,0,  7,11,3},
  {134,9,0,0,0,0,   7,11,2,4,9,3,6,8,1},
  {134,6,3,0,0,0,   7,11,2,4,9,3,  8,1,6},
  {134,6,3,0,0,0,   7,11,3,6,8,1,  2,4,9},
  {134,3,3,3,0,0,   7,11,3,  8,1,6,  2,4,9},
  {134,6,3,0,0,0,   7,11,2,4,8,1,  6,9,3},
  {134,9,0,0,0,0,   7,11,2,4,8,1,6,9,3},
  {134,9,0,0,0,0,   7,11,3,6,9,2,4,8,1},
  {134,3,6,0,0,0,   7,11,3,  8,1,6,9,2,4},
  {135,3,5,0,0,0,   6,9,3,  7,11,2,0,1},
  {135,8,0,0,0,0,   6,9,3,7,11,2,0,1},
  {135,8,0,0,0,0,   6,9,2,0,1,7,11,3},
  {135,5,3,0,0,0,   6,9,2,0,1,  7,11,3},
  {137,7,0,0,0,0,   7,11,9,4,0,8,6},
  {137,4,3,0,0,0,   7,11,9,6,  0,8,4},
  {144,6,0,0,0,0,   10,0,5,11,3,7},
  {144,3,3,0,0,0,   10,0,5,  11,3,7},
  {145,7,0,0,0,0,   8,4,5,11,3,7,10},
  {145,4,3,0,0,0,   8,4,5,10,  11,3,7},
  {146,9,0,0,0,0,   6,8,1,7,10,0,5,11,3},
  {146,3,6,0,0,0,   6,8,1,  11,3,7,10,0,5},
  {146,6,3,0,0,0,   6,8,0,5,11,3,  7,10,1},
  {146,9,0,0,0,0,   6,8,0,5,11,3,7,10,1},
  {146,6,3,0,0,0,   6,8,1,7,11,3,  0,5,10},
  {146,3,3,3,0,0,   6,8,1,  11,3,7,  0,5,10},
  {146,9,0,0,0,0,   6,8,0,5,10,1,7,11,3},
  {146,6,3,0,0,0,   6,8,0,5,10,1,  11,3,7},
  {147,5,3,0,0,0,   6,4,5,11,3,  10,1,7},
  {147,8,0,0,0,0,   6,4,5,11,3,7,10,1},
  {147,8,0,0,0,0,   6,4,5,10,1,7,11,3},
  {147,5,3,0,0,0,   6,4,5,10,1,  11,3,7},
  {148,9,0,0,0,0,   4,9,3,7,10,0,5,11,2},
  {148,6,3,0,0,0,   4,9,3,7,10,0,  5,11,2},
  {148,3,6,0,0,0,   4,9,2,  10,0,5,11,3,7},
  {148,9,0,0,0,0,   4,9,2,5,11,3,7,10,0},
  {148,6,3,0,0,0,   4,9,3,7,11,2,  10,0,5},
  {148,9,0,0,0,0,   4,9,3,7,11,2,5,10,0},
  {148,3,3,3,0,0,   4,9,2,  10,0,5,  3,7,11},
  {148,6,3,0,0,0,   4,9,2,5,10,0,  3,7,11},
  {149,5,3,0,0,0,   8,9,3,7,10,  2,5,11},
  {149,8,0,0,0,0,   8,9,2,5,11,3,7,10},
  {149,8,0,0,0,0,   8,9,3,7,11,2,5,10},
  {149,5,3,0,0,0,   8,9,2,5,10,  3,7,11},
  {150,12,0,0,0,0,   4,9,3,6,8,1,7,10,0,5,11,2},
  {150,9,3,0,0,0,   4,9,3,7,10,0,5,11,2,  6,8,1},
  {150,9,3,0,0,0,   4,9,3,6,8,1,7,10,0,  5,11,2},
  {150,6,3,3,0,0,   4,9,3,7,10,0,  6,8,1,  5,11,2},
  {150,3,9,0,0,0,   4,9,2,  6,8,1,7,10,0,5,11,3},
  {150,3,3,6,0,0,   4,9,2,  6,8,1,  7,10,0,5,11,3},
  {150,12,0,0,0,0,   4,9,2,5,11,3,6,8,1,7,10,0},
  {150,9,3,0,0,0,   4,9,2,5,11,3,7,10,0,  6,8,1},
  {150,9,3,0,0,0,   4,9,3,6,8,0,5,11,2,  7,10,1},
  {150,12,0,0,0,0,   4,9,3,7,10,1,6,8,0,5,11,2},
  {150,6,3,3,0,0,   4,9,3,6,8,0,  7,10,1,  5,11,2},
  {150,9,3,0,0,0,   4,9,3,7,10,1,6,8,0,  5,11,2},
  {150,3,6,3,0,0,   4,9,2,  6,8,0,5,11,3,  7,10,1},
  {150,3,9,0,0,0,   4,9,2,  6,8,0,5,11,3,7,10,1},
  {150,9,3,0,0,0,   4,9,2,5,11,3,6,8,0,  7,10,1},
  {150,12,0,0,0,0,   4,9,2,5,11,3,7,10,1,6,8,0},
  {150,9,3,0,0,0,   4,9,3,6,8,1,7,11,2,  5,10,0},
  {150,6,3,3,0,0,   4,9,3,7,11,2,  6,8,1,  5,10,0},
  {150,12,0,0,0,0,   4,9,3,6,8,1,7,11,2,5,10,0},
  {150,9,3,0,0,0,   4,9,3,7,11,2,5,10,0,  6,8,1},
  {150,3,6,3,0,0,   4,9,2,  6,8,1,7,11,3,  5,10,0},
  {150,3,3,3,3,0,   4,9,2,  6,8,1,  5,10,0,  7,11,3},
  {150,6,6,0,0,0,   4,9,2,5,10,0,  6,8,1,7,11,3},
  {150,6,3,3,0,0,   4,9,2,5,10,0,  6,8,1,  7,11,3},
  {150,12,0,0,0,0,   4,9,3,6,8,0,5,10,1,7,11,2},
  {150,6,6,0,0,0,   4,9,3,7,11,2,  6,8,0,5,10,1},
  {150,6,6,0,0,0,   4,9,3,6,8,0,  5,10,1,7,11,2},
  {150,12,0,0,0,0,   4,9,3,7,11,2,5,10,1,6,8,0},
  {150,3,9,0,0,0,   4,9,2,  6,8,0,5,10,1,7,11,3},
  {150,3,6,3,0,0,   4,9,2,  6,8,0,5,10,1,  7,11,3},
  {150,12,0,0,0,0,   4,9,2,5,10,1,7,11,3,6,8,0},
  {150,9,3,0,0,0,   4,9,2,5,10,1,6,8,0,  7,11,3},
  {150,3,9,0,0,0,   6,9,3,  4,8,1,7,10,0,5,11,2},
  {150,12,0,0,0,0,   6,9,3,7,10,0,5,11,2,4,8,1},
  {150,3,6,3,0,0,   6,9,3,  4,8,1,7,10,0,  5,11,2},
  {150,9,3,0,0,0,   6,9,3,7,10,0,4,8,1,  5,11,2},
  {150,12,0,0,0,0,   6,9,2,4,8,1,7,10,0,5,11,3},
  {150,6,6,0,0,0,   6,9,2,4,8,1,  7,10,0,5,11,3},
  {150,6,6,0,0,0,   6,9,2,5,11,3,  4,8,1,7,10,0},
  {150,12,0,0,0,0,   6,9,2,5,11,3,7,10,0,4,8,1},
  {150,3,6,3,0,0,   6,9,3,  4,8,0,5,11,2,  7,10,1},
  {150,6,6,0,0,0,   6,9,3,7,10,1,  4,8,0,5,11,2},
  {150,3,3,3,3,0,   6,9,3,  4,8,0,  7,10,1,  5,11,2},
  {150,6,3,3,0,0,   6,9,3,7,10,1,  4,8,0,  5,11,2},
  {150,9,3,0,0,0,   6,9,2,4,8,0,5,11,3,  7,10,1},
  {150,12,0,0,0,0,   6,9,2,4,8,0,5,11,3,7,10,1},
  {150,6,3,3,0,0,   6,9,2,5,11,3,  4,8,0,  7,10,1},
  {150,9,3,0,0,0,   6,9,2,5,11,3,7,10,1,  4,8,0},
  {150,3,6,3,0,0,   6,9,3,  4,8,1,7,11,2,  5,10,0},
  {150,9,3,0,0,0,   6,9,3,7,11,2,4,8,1,  5,10,0},
  {150,3,9,0,0,0,   6,9,3,  4,8,1,7,11,2,5,10,0},
  {150,12,0,0,0,0,   6,9,3,7,11,2,5,10,0,4,8,1},
  {150,9,3,0,0,0,   6,9,2,4,8,1,7,11,3,  5,10,0},
  {150,6,3,3,0,0,   6,9,2,4,8,1,  5,10,0,  7,11,3},
  {150,12,0,0,0,0,   6,9,2,5,10,0,4,8,1,7,11,3},
  {150,9,3,0,0,0,   6,9,2,5,10,0,4,8,1,  7,11,3},
  {150,3,9,0,0,0,   6,9,3,  4,8,0,5,10,1,7,11,2},
  {150,12,0,0,0,0,   6,9,3,7,11,2,4,8,0,5,10,1},
  {150,3,3,6,0,0,   6,9,3,  4,8,0,  5,10,1,7,11,2},
  {150,9,3,0,0,0,   6,9,3,7,11,2,5,10,1,  4,8,0},
  {150,12,0,0,0,0,   6,9,2,4,8,0,5,10,1,7,11,3},
  {150,9,3,0,0,0,   6,9,2,4,8,0,5,10,1,  7,11,3},
  {150,9,3,0,0,0,   6,9,2,5,10,1,7,11,3,  4,8,0},
  {150,6,3,3,0,0,   6,9,2,5,10,1,  4,8,0,  7,11,3},
  {151,3,3,3,0,0,   6,9,3,  10,1,7,  2,5,11},
  {151,6,3,0,0,0,   6,9,3,7,10,1,  2,5,11},
  {151,6,3,0,0,0,   6,9,2,5,11,3,  10,1,7},
  {151,9,0,0,0,0,   6,9,2,5,11,3,7,10,1},
  {151,3,6,0,0,0,   6,9,3,  10,1,7,11,2,5},
  {151,9,0,0,0,0,   6,9,3,7,11,2,5,10,1},
  {151,9,0,0,0,0,   6,9,2,5,10,1,7,11,3},
  {151,6,3,0,0,0,   6,9,2,5,10,1,  7,11,3},
  {152,7,0,0,0,0,   9,6,7,10,0,5,11},
  {152,4,3,0,0,0,   9,6,7,11,  10,0,5},
  {153,4,4,0,0,0,   10,8,6,7,  11,9,4,5},
  {153,8,0,0,0,0,   10,8,6,7,11,9,4,5},
  {153,8,0,0,0,0,   10,8,4,5,11,9,6,7},
  {153,4,4,0,0,0,   10,8,4,5,  11,9,6,7},
  {154,8,0,0,0,0,   9,8,1,7,10,0,5,11},
  {154,5,3,0,0,0,   9,8,0,5,11,  1,7,10},
  {154,5,3,0,0,0,   9,8,1,7,11,  0,5,10},
  {154,8,0,0,0,0,   9,8,0,5,10,1,7,11},
  {155,4,3,0,0,0,   9,4,5,11,  10,1,7},
  {155,7,0,0,0,0,   9,4,5,10,1,7,11},
  {156,8,0,0,0,0,   4,6,7,10,0,5,11,2},
  {156,5,3,0,0,0,   4,6,7,10,0,  11,2,5},
  {156,5,3,0,0,0,   4,6,7,11,2,  10,0,5},
  {156,8,0,0,0,0,   4,6,7,11,2,5,10,0},
  {157,4,3,0,0,0,   8,6,7,10,  11,2,5},
  {157,7,0,0,0,0,   8,6,7,11,2,5,10},
  {158,9,0,0,0,0,   4,8,1,7,10,0,5,11,2},
  {158,6,3,0,0,0,   4,8,1,7,10,0,  11,2,5},
  {158,6,3,0,0,0,   4,8,0,5,11,2,  1,7,10},
  {158,3,3,3,0,0,   4,8,0,  11,2,5,  1,7,10},
  {158,6,3,0,0,0,   4,8,1,7,11,2,  5,10,0},
  {158,9,0,0,0,0,   4,8,1,7,11,2,5,10,0},
  {158,9,0,0,0,0,   4,8,0,5,10,1,7,11,2},
  {158,3,6,0,0,0,   4,8,0,  11,2,5,10,1,7},
  {159,3,3,0,0,0,   10,1,7,  11,2,5},
  {159,6,0,0,0,0,   10,1,7,11,2,5},
  {161,7,0,0,0,0,   8,4,0,10,11,3,1},
  {161,3,4,0,0,0,   8,4,0,  10,11,3,1},
  {164,7,0,0,0,0,   4,9,3,1,10,11,2},
  {164,3,4,0,0,0,   4,9,2,  10,11,3,1},
  {165,4,4,0,0,0,   8,9,3,1,  10,11,2,0},
  {165,8,0,0,0,0,   8,9,2,0,10,11,3,1},
  {165,8,0,0,0,0,   8,9,3,1,10,11,2,0},
  {165,4,4,0,0,0,   8,9,2,0,  10,11,3,1},
  {166,8,0,0,0,0,   10,11,2,4,9,3,6,8},
  {166,5,3,0,0,0,   10,11,3,6,8,  2,4,9},
  {166,5,3,0,0,0,   10,11,2,4,8,  3,6,9},
  {166,8,0,0,0,0,   10,11,3,6,9,2,4,8},
  {167,3,4,0,0,0,   6,9,3,  10,11,2,0},
  {167,7,0,0,0,0,   6,9,2,0,10,11,3},
  {169,5,3,0,0,0,   10,11,9,4,0,  6,1,8},
  {169,8,0,0,0,0,   10,11,9,4,0,8,6,1},
  {169,8,0,0,0,0,   10,11,9,6,1,8,4,0},
  {169,5,3,0,0,0,   10,11,9,6,1,  4,0,8},
  {173,3,4,0,0,0,   8,6,1,  10,11,2,0},
  {173,7,0,0,0,0,   8,6,1,10,11,2,0},
  {180,8,0,0,0,0,   4,9,3,1,0,5,11,2},
  {180,5,3,0,0,0,   4,9,3,1,0,  5,11,2},
  {180,3,5,0,0,0,   4,9,2,  5,11,3,1,0},
  {180,8,0,0,0,0,   4,9,2,5,11,3,1,0},
  {181,4,3,0,0,0,   8,9,3,1,  5,11,2},
  {181,7,0,0,0,0,   8,9,2,5,11,3,1},
  {182,9,0,0,0,0,   5,11,2,4,9,3,6,8,0},
  {182,3,6,0,0,0,   5,11,2,  8,0,4,9,3,6},
  {182,6,3,0,0,0,   5,11,3,6,8,0,  4,9,2},
  {182,9,0,0,0,0,   5,11,3,6,8,0,4,9,2},
  {182,6,3,0,0,0,   5,11,2,4,8,0,  3,6,9},
  {182,3,3,3,0,0,   5,11,2,  8,0,4,  3,6,9},
  {182,9,0,0,0,0,   5,11,3,6,9,2,4,8,0},
  {182,6,3,0,0,0,   5,11,3,6,9,2,  8,0,4},
  {183,3,3,0,0,0,   6,9,3,  5,11,2},
  {183,6,0,0,0,0,   6,9,2,5,11,3},
  {185,4,3,0,0,0,   5,11,9,4,  1,8,6},
  {185,7,0,0,0,0,   5,11,9,6,1,8,4},
  {188,7,0,0,0,0,   4,6,1,0,5,11,2},
  {188,4,3,0,0,0,   4,6,1,0,  5,11,2},
  {190,6,0,0,0,0,   4,8,0,5,11,2},
  {190,3,3,0,0,0,   4,8,0,  5,11,2},
  {193,7,0,0,0,0,   8,4,2,3,7,5,0},
  {193,3,4,0,0,0,   8,4,0,  7,5,2,3},
  {194,7,0,0,0,0,   6,8,1,7,5,2,3},
  {194,3,4,0,0,0,   6,8,1,  7,5,2,3},
  {195,4,4,0,0,0,   6,4,2,3,  7,5,0,1},
  {195,8,0,0,0,0,   6,4,2,3,7,5,0,1},
  {195,8,0,0,0,0,   6,4,0,1,7,5,2,3},
  {195,4,4,0,0,0,   6,4,0,1,  7,5,2,3},
  {198,8,0,0,0,0,   7,5,4,9,3,6,8,1},
  {198,5,3,0,0,0,   7,5,4,9,3,  8,1,6},
  {198,5,3,0,0,0,   7,5,4,8,1,  9,3,6},
  {198,8,0,0,0,0,   7,5,4,8,1,6,9,3},
  {199,3,4,0,0,0,   6,9,3,  7,5,0,1},
  {199,7,0,0,0,0,   6,9,3,7,5,0,1},
  {201,5,3,0,0,0,   7,5,0,8,6,  2,9,4},
  {201,8,0,0,0,0,   7,5,2,9,4,0,8,6},
  {201,8,0,0,0,0,   7,5,0,8,4,2,9,6},
  {201,5,3,0,0,0,   7,5,2,9,6,  0,8,4},
  {203,3,4,0,0,0,   9,4,2,  7,5,0,1},
  {203,7,0,0,0,0,   9,4,0,1,7,5,2},
  {210,8,0,0,0,0,   6,8,1,7,10,0,2,3},
  {210,3,5,0,0,0,   6,8,1,  7,10,0,2,3},
  {210,5,3,0,0,0,   6,8,0,2,3,  7,10,1},
  {210,8,0,0,0,0,   6,8,0,2,3,7,10,1},
  {211,4,3,0,0,0,   6,4,2,3,  7,10,1},
  {211,7,0,0,0,0,   6,4,2,3,7,10,1},
  {214,9,0,0,0,0,   7,10,0,4,9,3,6,8,1},
  {214,6,3,0,0,0,   7,10,0,4,9,3,  6,8,1},
  {214,3,6,0,0,0,   7,10,1,  9,3,6,8,0,4},
  {214,9,0,0,0,0,   7,10,1,6,8,0,4,9,3},
  {214,6,3,0,0,0,   7,10,0,4,8,1,  9,3,6},
  {214,9,0,0,0,0,   7,10,0,4,8,1,6,9,3},
  {214,3,3,3,0,0,   7,10,1,  9,3,6,  0,4,8},
  {214,6,3,0,0,0,   7,10,1,6,9,3,  0,4,8},
  {215,3,3,0,0,0,   6,9,3,  7,10,1},
  {215,6,0,0,0,0,   6,9,3,7,10,1},
  {217,4,3,0,0,0,   7,10,8,6,  2,9,4},
  {217,7,0,0,0,0,   7,10,8,4,2,9,6},
  {218,7,0,0,0,0,   9,8,1,7,10,0,2},
  {218,4,3,0,0,0,   9,8,0,2,  7,10,1},
  {222,6,0,0,0,0,   4,8,1,7,10,0},
  {222,3,3,0,0,0,   4,8,0,  7,10,1},
  {225,5,3,0,0,0,   8,4,2,3,1,  10,5,0},
  {225,8,0,0,0,0,   8,4,0,10,5,2,3,1},
  {225,8,0,0,0,0,   8,4,2,3,1,10,5,0},
  {225,3,5,0,0,0,   8,4,0,  10,5,2,3,1},
  {227,4,3,0,0,0,   6,4,2,3,  10,5,0},
  {227,7,0,0,0,0,   6,4,0,10,5,2,3},
  {229,4,3,0,0,0,   8,9,3,1,  10,5,0},
  {229,7,0,0,0,0,   8,9,3,1,10,5,0},
  {230,7,0,0,0,0,   10,5,4,9,3,6,8},
  {230,4,3,0,0,0,   10,5,4,8,  9,3,6},
  {233,3,3,3,0,0,   10,5,0,  2,9,4,  6,1,8},
  {233,6,3,0,0,0,   10,5,2,9,4,0,  6,1,8},
  {233,6,3,0,0,0,   10,5,0,8,6,1,  2,9,4},
  {233,9,0,0,0,0,   10,5,2,9,4,0,8,6,1},
  {233,3,6,0,0,0,   10,5,0,  2,9,6,1,8,4},
  {233,9,0,0,0,0,   10,5,2,9,6,1,8,4,0},
  {233,9,0,0,0,0,   10,5,0,8,4,2,9,6,1},
  {233,6,3,0,0,0,   10,5,2,9,6,1,  8,4,0},
  {235,3,3,0,0,0,   9,4,2,  10,5,0},
  {235,6,0,0,0,0,   9,4,0,10,5,2},
  {237,3,3,0,0,0,   8,6,1,  10,5,0},
  {237,6,0,0,0,0,   8,6,1,10,5,0},
  {246,6,0,0,0,0,   8,0,4,9,3,6},
  {246,3,3,0,0,0,   8,0,4,  9,3,6},
  {249,3,3,0,0,0,   1,8,6,  2,9,4},
  {249,6,0,0,0,0,   1,8,4,2,9,6}
};

#endif
