//**********************************************************************
// Copyright 2006 John A. Trangenstein
//
// This software is made available for research and instructional use 
// only. 
// You may copy and use this software without charge for these 
// non-commercial purposes, provided that the copyright notice and 
// associated text is reproduced on all copies.  
// For all other uses (including distribution of modified versions), 
// please contact the author at
//   John A. Trangenstein
//   Department of Mathematics
//   Duke University
//   Durham, NC 27708-0320
//   USA
// or
//   johnt@math.duke.edu
// 
// This software is made available "as is" without any assurance that it
// is completely correct, or that it will work for your purposes.  
// Use the software at your own risk.
//**********************************************************************
#ifndef XCOLORMAP_H
#define XCOLORMAP_H "$Header: /home/faculty/johnt/cvs/deal_new/graphics/XColormap.H,v 1.1 2009/08/20 17:31:47 johnt Exp $"
#include <iostream>
#include <X11/Intrinsic.h>
#include "VC.H"

class XColormap : public VirtualColormap {
  private:
    Pixel *cmap_colors;
    Colormap cmap;
    Display *display;
    Visual *visual;
    int depth;
    int screen;

    XColormap( const XColormap&);
    void installNewMap(Visual*,int&,XColor*);
    BOOLEAN allocColorCells(XColor*);
  public:
    XColormap(Palette*,const char* = 0,Display* = 0);
    virtual ~XColormap();
    Pixel allocColor(const char*);
    void installNewVisual(Window,Visual*);
    Display* getDisplay() const { return display; }
    int getDepth() const { return depth; }
    int getScreen() const { return screen; }
    Colormap getColormap() const { return cmap; }
    Visual* getVisual() const { return visual; }
    Pixel getColor(int i) const { return cmap_colors[i]; }
    virtual void printOn(ostream& os = cerr) const;
};
#endif
