//**********************************************************************
// Copyright 2006 John A. Trangenstein
//
// This software is made available for research and instructional use 
// only. 
// You may copy and use this software without charge for these 
// non-commercial purposes, provided that the copyright notice and 
// associated text is reproduced on all copies.  
// For all other uses (including distribution of modified versions), 
// please contact the author at
//   John A. Trangenstein
//   Department of Mathematics
//   Duke University
//   Durham, NC 27708-0320
//   USA
// or
//   johnt@math.duke.edu
// 
// This software is made available "as is" without any assurance that it
// is completely correct, or that it will work for your purposes.  
// Use the software at your own risk.
//**********************************************************************
#ifndef ALIGN_H
#define ALIGN_H "$Header: /home/faculty/johnt/cvs/deal_new/memdebug/Align.H,v 1.1 2009/08/20 17:33:32 johnt Exp $"

#include "Types.H"

#ifdef ALPHA
# define ALIGN_SIZE 8
# define ALIGN_EXPONENT 3    //2^ALIGN_EXPONENT=ALIGN_SIZE
# define INT_EXPONENT 2  //2^INT_EXPONENT=sizeof(int)
#else
# define ALIGN_SIZE 8
# define ALIGN_EXPONENT 3    //2^ALIGN_EXPONENT=ALIGN_SIZE
# define INT_EXPONENT 2  //2^INT_EXPONENT=sizeof(int)
#endif

inline void Align(size_t &n) {
  size_t q=n>>ALIGN_EXPONENT;
  size_t m=q*ALIGN_SIZE;
  n=  m<n ? m+ALIGN_SIZE : m;
}

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

//Assumes ptr_in and ptr_out are aligned on a word boundary

inline void rawCopy(const void* ptr_in,void* ptr_out,
size_t nbytes) {
  size_t count=nbytes>>INT_EXPONENT;
  const int *iin=reinterpret_cast<const int*>(ptr_in);
  int *iout=reinterpret_cast<int*>(ptr_out);
  for (size_t i=0;i<count;i++) iout[i]=iin[i];

  const char *chin=reinterpret_cast<const char*>(ptr_in);
  char *chout=reinterpret_cast<char*>(ptr_out);
  for (size_t j=count*sizeof(int);j<nbytes;j++) chout[j]=chin[j];
}

#endif
