//**********************************************************************
// Copyright 2006 John A. Trangenstein
//
// This software is made available for research and instructional use 
// only. 
// You may copy and use this software without charge for these 
// non-commercial purposes, provided that the copyright notice and 
// associated text is reproduced on all copies.  
// For all other uses (including distribution of modified versions), 
// please contact the author at
//   John A. Trangenstein
//   Department of Mathematics
//   Duke University
//   Durham, NC 27708-0320
//   USA
// or
//   johnt@math.duke.edu
// 
// This software is made available "as is" without any assurance that it
// is completely correct, or that it will work for your purposes.  
// Use the software at your own risk.
//**********************************************************************
// "$Header: /home/faculty/johnt/cvs/deal_new/memdebug/Debug.C,v 1.1 2009/08/20 17:33:32 johnt Exp $"
#include "Debug.H"
#include <iostream>
#include "Errors.H"
#include "Types.H"
void* WatchPoint::watch_point=0;
void* WatchPoint::watch_point_address=0;
const void* WatchPointer::watch_pointer=0;
const void** WatchPointer::watch_pointer_address=0;
extern "C" {
  void F77_NAME(print_loc)(const void *p) {
    cout << p << endl;
    cout << "\tdouble = " << *(double*) p << endl;
    cout << "\tfloat = " << *(float*) p << endl;
    cout << "\tint = " << *(int*) p << endl;
  }
  void F77_NAME(print_watch_loc)() { WatchPoint::print(); }
  void F77_NAME(check_watch_loc)() { WatchPoint::check(); }
  void F77_NAME(print_double)(const double *p) {
    cout << p << "\tdouble = " << *(double*) p << endl;
  }
  void F77_NAME(print_float)(const float *p) {
    cout << p << "\tfloat = " << *(float*) p << endl;
  }
  void F77_NAME(print_int)(const int *p) {
    cout << p << "\tint = " << *(int*) p << endl;
  }
  void F77_NAME(check_double_size)(const REAL *p,const REAL *p1) {
    CHECK_SAME(p1,p+1)
  }
  void F77_NAME(check_single_size)(const float *p,const float *p1) {
    CHECK_SAME(p1,p+1)
  }
  void F77_NAME(check_complex_size)(const COMPLEX *p,const COMPLEX *p1){
    CHECK_SAME(p1,p+1)
  }
  void F77_NAME(check_integer_size)(const INTEGER *p,const INTEGER *p1){
    CHECK_SAME(p1,p+1)
  }
  void F77_NAME(check_logical_size)(const BOOLEAN *p,const BOOLEAN *p1){
    CHECK_SAME(p1,p+1)
  }
}

void WatchPoint::set(float **p) { 
  watch_point_address=static_cast<void*>(p);
  watch_point=static_cast<void*>(*p);
}
void WatchPoint::set(double **p) { 
  watch_point_address=static_cast<void*>(p);
  watch_point=static_cast<void*>(*p);
}
void WatchPoint::set(int **p) { 
  watch_point_address=static_cast<void*>(p);
  watch_point=static_cast<void*>(*p);
}
void WatchPoint::set(unsigned int **p) { 
  watch_point_address=static_cast<void*>(p);
  watch_point=static_cast<void*>(*p);
}
void WatchPoint::set(long **p) { 
  watch_point_address=static_cast<void*>(p);
  watch_point=static_cast<void*>(*p);
}
void WatchPoint::set(unsigned long **p) { 
  watch_point_address=static_cast<void*>(p);
  watch_point=static_cast<void*>(*p);
}
void WatchPoint::set(short **p) { 
  watch_point_address=static_cast<void*>(p);
  watch_point=static_cast<void*>(*p);
}
void WatchPoint::set(unsigned short **p) { 
  watch_point_address=static_cast<void*>(p);
  watch_point=static_cast<void*>(*p);
}
void WatchPoint::set(void **p) { 
  watch_point_address=static_cast<void*>(p);
  watch_point=static_cast<void*>(*p);
}
void WatchPoint::unset() { watch_point=0; watch_point_address=0; }
void WatchPoint::print() { 
  if (watch_point) F77_NAME(print_loc)(watch_point);
}
void WatchPoint::check() { 
  if (watch_point_address) {
    ASSERT(watch_point == static_cast<void*>(watch_point_address));
  }
}


#include <unistd.h>
void wait() {
  sleep(1);
  char dummy[80];
  cout << "hit RETURN to continue" << endl;
  cin.getline(dummy,80);
}
