//**********************************************************************
// Copyright 2006 John A. Trangenstein
//
// This software is made available for research and instructional use 
// only. 
// You may copy and use this software without charge for these 
// non-commercial purposes, provided that the copyright notice and 
// associated text is reproduced on all copies.  
// For all other uses (including distribution of modified versions), 
// please contact the author at
//   John A. Trangenstein
//   Department of Mathematics
//   Duke University
//   Durham, NC 27708-0320
//   USA
// or
//   johnt@math.duke.edu
// 
// This software is made available "as is" without any assurance that it
// is completely correct, or that it will work for your purposes.  
// Use the software at your own risk.
//**********************************************************************
#ifndef TYPES_H
#define TYPES_H "$Header: /home/faculty/johnt/cvs/deal_new/memdebug/Types.H,v 1.1 2009/08/20 17:33:33 johnt Exp $"

#include <complex>
#include <malloc.h>

using namespace std;

typedef int INTEGER;
typedef int INT;
typedef short SHRT;
typedef long LONG;

typedef unsigned int UINT;
typedef short unsigned int USHRT;
typedef long unsigned int ULONG;

typedef double REAL;
typedef complex<REAL> COMPLEX;
typedef unsigned char BYTE;
typedef unsigned short RASTER;

#ifdef ALPHA
# ifdef __DECCXX
    typedef bool BOOLEAN;
#   define NEITHER 3
#   ifndef FALSE
#    define FALSE false
#   endif
#   ifndef TRUE
#    define TRUE true
#   endif
# else
//  setting BOOLEAN to
//    bool has size 8 and no Fortran logical type has size > 4
//    int causes instantiation problems for templates
//    unsigned int causes confusion with instantiation
//    char gives problems with        while (test) {}
//  the following is consistent with logical*2 in Fortran:
//  typedef unsigned char BOOLEAN;
    typedef bool BOOLEAN;
#   define NEITHER 3
#   ifndef FALSE
#    define FALSE 0
#   endif
#   ifndef TRUE
#    define TRUE 1
#   endif
# endif
#else
  typedef bool BOOLEAN;
# define NEITHER false
# ifndef FALSE
#  define FALSE false
# endif
# ifndef TRUE
#  define TRUE true
# endif
#endif
#define PRINT_BOOLEAN(b) ((b)?"TRUE":"FALSE")

enum HAND{LEFT_HAND,RIGHT_HAND};
inline HAND otherHand(HAND h) {
  return (h==LEFT_HAND ? RIGHT_HAND : LEFT_HAND);
}
ostream& operator<<(ostream&,HAND);

enum READ_PLOT_RECORD{read_first_marks,
                      read_until_bracket};
ostream& operator<<(ostream&,READ_PLOT_RECORD);
#endif
