#ifndef MG_TRANSFER_H
#define MG_TRANSFER_H "$Header: /home/faculty/johnt/cvs/deal_new/mg/MGTransfer.H,v 1.1 2009/08/20 17:34:10 johnt Exp $"
//----------------------------------------------------------------------
//   $Id: MGTransfer.H,v 1.1 2009/08/20 17:34:10 johnt Exp $
//   Version: $Name:  $
//
//   Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003 by the deal.II authors
//
//   This file is subject to QPL and may not be  distributed
//   without copyright and license information. Please refer
//   to the file deal.II/doc/license.html for the  text  and
//   further information on this license.
//
//----------------------------------------------------------------------
//
//modified from deal.II/deal.II/include/multigrid/mg_transfer.h
//  by John Trangenstein, August 2009
//**********************************************************************
// Copyright 2009 John A. Trangenstein
//
// This software is made available for research and instructional use 
// only. 
// You may copy and use this software without charge for these 
// non-commercial purposes, provided that the copyright notice and 
// associated text is reproduced on all copies.  
// For all other uses (including distribution of modified versions), 
// please contact the author at
//   John A. Trangenstein
//   Department of Mathematics
//   Duke University
//   Durham, NC 27708-0320
//   USA
// or
//   johnt@math.duke.edu
// 
// This software is made available "as is" without any assurance that it
// is completely correct, or that it will work for your purposes.  
// Use the software at your own risk.
//**********************************************************************

#include <MGDofHandler.H>
#include <MGLevelObject.H>

class MGTransfer {
  private:
    const MGDofHandler &mg_dof_handler;
    NumPtr<int> sizes;
    NumPtr<SparsityPattern*> prolongation_sparsity_patterns;
    NumPtr<SparseMatrix*> prolongation_matrices;
    NumPtr<set<int> > slave_mg_dof_indices_on_level;
  public:
    MGTransfer(const MGDofHandler &mgdh) : mg_dof_handler(mgdh) 
      { }
    virtual ~MGTransfer();
    int prolongationSize(int ln,int i) const {
      return prolongation_matrices[ln]->size(i);
    }
    void buildMatrices(const NumPtr<set<int> >&);
    virtual void prolongationAndAdd(int,Vector&,const Vector&) const;
    virtual void restriction(int,Vector&,const Vector&) const;
    void copyToMG(MGLevelObject<Vector>&,const Vector&) const;
    void copyFromMG(Vector&,const MGLevelObject<Vector>&) const;
    void copyFromMGAdd(Vector&,const MGLevelObject<Vector>&) const;
    void copySlaveDofs(int,Vector&,const Vector&) const;
    virtual void printOn(ostream&) const;
};

#endif
