      program heatmain
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c     from input file:
      integer ncells
      parameter (ncells=100)
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      double precision roundoff,small,huge,undefind
      common/machine/roundoff,small,huge,undefind
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      double precision
     &  uold(0:ncells),
     &  unew(0:ncells),
     &  x(0:ncells),
     &  matrix(0:ncells,0:1),
     &  matrix_periodic(0:ncells,0:2)

c     from input file:
      integer nsteps
      double precision tmax,decay,diffusion

c     local variables
      integer i,fi,la,ifirst,ilast
      integer istep
      double precision dt,dx,t
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      roundoff=1.d-14
      small=1.d-20
      huge=1.d300
      undefind=1.d300

c     from input file:
      nsteps=10000
      tmax=0.05d0
      decay=0.45d0
      diffusion=1.d0

c     array dimension bounds for subroutine calls:
      fi=0
      la=ncells
c     subscript bounds for subroutine calls:
      ifirst=0
      ilast=ncells

c     computational work:
      call initialize(fi,la,ifirst,ilast, uold,x)
      dx=x(1)-x(0)
      dt=decay*dx**2/diffusion

      istep=0
      t=0.d0
      do while (istep.lt.nsteps .and. t.lt.tmax)
c       call explicit_centered(fi,la,ifirst,ilast, diffusion,dt,dx,
c    &    uold,unew)
c       call implicit_centered(fi,la,ifirst,ilast, diffusion,dt,dx,
c    &    uold, matrix,unew)
c       call implicit_centered_periodic(fi,la,ifirst,ilast, 
c    &    diffusion,dt,dx, uold, matrix_periodic,unew)
        call crank_nicolson(fi,la,ifirst,ilast, 
     &    diffusion,dt,dx, uold, matrix,unew)
        t=t+dt
        istep=istep+1

c       since fortran doesn't have pointers, have to copy arrays
        do i=fi,la
          uold(i)=unew(i)
        enddo
      enddo

c     write results, plot later
      do i=ifirst,ilast
        print *,x(i),uold(i)
      enddo
     
      stop
      end
