      subroutine fourier(nplot,decay,displo,disphi,disslo,disshi,
     &  theta,dissipation,dispersion)
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      include "const.i"
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      integer nplot
      double precision decay,displo,disphi,disslo,disshi
      double precision 
     &  theta(0:nplot),
     &  dissipation(0:nplot),
     &  dispersion(0:nplot)

      integer i
      double precision angle,rez,coz,znorm
      double complex z

      double precision realz,cimagz,t,c
c     double precision eta8
c     double precision gamma,ts
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c explicit centered:
      realz(t,c)=1.d0-4.d0*c*sin(0.5d0*t)**2
      cimagz(t,c)=0.d0
c implicit centered:
c     realz(t,c)=1.d0/(1.d0+4.d0*c*sin(0.5d0*t)**2)
c     cimagz(t,c)=0.d0
c crank-nicolson
c     realz(t,c)=(1.d0-2.d0*c*sin(0.5d0*t)**2)
c    &          /(1.d0+2.d0*c*sin(0.5d0*t)**2)
c     cimagz(t,c)=0.d0
c adams-bashforth larger
c     realz(t,c)=0.5d0*(1.d0-6.d0*c*sin(0.5d0*t)**2
c    &  + sqrt( ((1.d0-6.d0*c*sin(0.5d0*t)**2)**2
c    &          + 8.d0*c*sin(0.5d0*t)**2 ) ) )
c     cimagz(t,c)=0.d0
c adams-bashforth smaller
c     realz(t,c)=0.5d0*(1.d0-6.d0*c*sin(0.5d0*t)**2
c    &  - sqrt( ((1.d0-6.d0*c*sin(0.5d0*t)**2)**2
c    &          + 8.d0*c*sin(0.5d0*t)**2 ) ) )
c     cimagz(t,c)=0.d0
c
c BDF below
c DIRK below
c     realz(t,c)=(1.d0-4.d0*c*(sqrt(2.d0)-1.d0)*sin(0.5d0*t)**2)
c    &          /(1.d0+4.d0*(1.d0-sqrt(0.5d0))*c*sin(0.5d0*t)**2)
c     cimagz(t,c)=0.d0
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      do i=0,nplot
c       explicit centered, implicit centered, crank-nicolson, etc.:
        rez=realz(theta(i),decay)
        coz=cimagz(theta(i),decay)

c       BDF:
c       eta8=8.d0*decay*sin(0.5d0*theta(i))**2
c       if (eta8.le.1.d0) then
c         rez=(2.d0+sqrt(1.d0-eta8))/(3.d0+eta8)
c         coz=0.d0
c       else
c         rez=2.d0/(3.d0+eta8)
c         coz=-(sqrt(eta8-1.d0)/(3.d0+eta8))
c       endif

c       DIRK:
c       gamma=1.d0-sqrt(0.5d0)
c       ts=4.d0*decay*sin(0.5d0*theta(i))**2
c       rez=(1.d0-(1.d0-2.d0*gamma)*ts)/(1.d0+gamma*ts)**2
c       coz=0.d0

c       if (i.eq.0) then
c         print *, "theta = ",theta(i)
c         print *, "rez,coz = ",rez,coz
c       endif
        z=dcmplx(rez,coz)
c       if (i.eq.0) then
c         print *, "z = ",z
c         print *, "decay = ",decay
c       endif
        if (abs(z).gt.0.d0) z=z**(1.d0/decay)
c       rez=realpart(z)
c       coz=imag(z)
        rez=real(z)
        coz=aimag(z)
        znorm=sqrt(rez**2+coz**2)
        dissipation(i)=exp(-(theta(i)**2))-znorm
c       if (i.eq.0) then
c         print *, "decay,theta,z = ",decay,theta(i),z
c         print *, "znorm,dissipation = ",znorm,dissipation(i)
c       endif
        if (theta(i).gt.0.d0) then
          if (znorm.le.0.d0) znorm=1.d0
          rez=max(-1.d0,min(1.d0,rez/znorm))
          coz=max(-1.d0,min(1.d0,coz/znorm))
c         print *, "rez,coz = ",rez,coz
c         if (coz.lt.0.d0) then
            angle=-acos(rez)
c         else 
c           angle=acos(rez)-2.d0*pi
c         endif
c         print *, "angle = ",angle
c         if (rez.gt.0.) angle=2.d0*pi+angle
c         print *, "angle = ",angle
          dispersion(i)=angle
        else 
          dispersion(i)=0.d0
        endif
c       print *, "dispersion = ",dispersion(i)

        displo=min(displo,dispersion(i))
        disphi=max(disphi,dispersion(i))
        disslo=min(disslo,dissipation(i))
        disshi=max(disshi,dissipation(i))
      enddo

      return
      end
