      subroutine initialize(dt,n0,n1,order,
     &  fmat0,fmat1,mat0,mat1,u,x0,x1)
c     ******************************************************************
      double precision pi
      common/constant/pi

      double precision dt
      integer n0,n1,order

      double precision fmat0(1:n0-1,-1:1),fmat1(1:n1-1,-1:1),
     &  mat0(1:n0-1,-1:1),mat1(1:n1-1,-1:1),u(0:n0,0:n1),
     &  x0(0:n0),x1(0:n1)

      double precision dt2,dx,dx2inv,dy,dy2inv,sy,x,y
      integer ie0,ie1
c     ******************************************************************
c     print *, "in initialize, dt,n0,n1,order = ",dt,n0,n1,order
      dt2=dt
      if (order.eq.2) dt2=dt*0.5d0
      dx=1.d0/dble(n0)
      dx2inv=1.d0/(dx*dx)
      x=0.d0
      do ie0=0,n0
        x0(ie0)=x
        x=x+dx
      enddo
      x0(n0)=1.d0
c     do ie0=0,n0
c       print *, "x0[",ie0,"] = ",x0(ie0)
c     enddo
c     first direction split matrix
      do ie0=1,n0-1
        mat0(ie0,-1)=-dx2inv
        mat0(ie0,0)=2.*dx2inv
        mat0(ie0,1)=mat0(ie0,-1)
        fmat0(ie0,-1)=mat0(ie0,-1)*dt2
        fmat0(ie0,0)=1.d0+mat0(ie0,0)*dt2
        fmat0(ie0,1)=fmat0(ie0,-1)
      enddo
c     do ie0=1,n0-1
c       print *, "mat0[",ie0,",*] = ",
c    &    mat0(ie0,-1),mat0(ie0,0),mat0(ie0,1)
c     enddo
c     do ie0=1,n0-1
c       print *, "fmat0[",ie0,",*] = ",
c    &    fmat0(ie0,-1),fmat0(ie0,0),fmat0(ie0,1)
c     enddo

      dy=1.d0/dble(n1)
      dy2inv=1.d0/(dy*dy)
      y=0.d0
      do ie1=0,n1
        x1(ie1)=y
        y=y+dy
      enddo
      x1(n1)=1.d0
c     do ie1=0,n1
c       print *, "x1[",ie1,"] = ",x1(ie1)
c     enddo
c     second direction split matrix
      do ie1=1,n1-1
        mat1(ie1,-1)=-dy2inv
        mat1(ie1,0)=2.*dy2inv
        mat1(ie1,1)=mat1(ie1,-1)
        fmat1(ie1,-1)=mat1(ie1,-1)*dt2
        fmat1(ie1,0)=1.d0+mat1(ie1,0)*dt2
        fmat1(ie1,1)=fmat1(ie1,-1)
      enddo
c     do ie1=1,n1-1
c       print *, "mat1[",ie1,",*] = ",
c    &    mat1(ie1,-1),mat1(ie1,0),mat1(ie1,1)
c     enddo
c     do ie1=1,n1-1
c       print *, "fmat1[",ie1,",*] = ",
c    &    fmat1(ie1,-1),fmat1(ie1,0),fmat1(ie1,1)
c     enddo
c     initial separation of variables solution
      do ie1=0,n1
        sy=sin(4.d0*pi*x1(ie1))
        do ie0=0,n0
          u(ie0,ie1)=sin(2.d0*pi*x0(ie0))*sy
        enddo
        u(n0,ie1)=0.d0
      enddo
      do ie0=0,n0
        u(ie0,n1)=0.d0
      enddo
c     do ie1=0,n1
c       do ie0=0,n0
c         print *, "u[",ie0,",",ie1,"] = ",u(ie0,ie1)
c       enddo
c     enddo
c     tridiagonal factorization
      do ie0=1,n0-2
        ip1=ie0+1
        fmat0(ip1,-1)=fmat0(ip1,-1)/fmat0(ie0,0)
        fmat0(ip1,0)=fmat0(ip1,0)-fmat0(ip1,-1)*fmat0(ie0,1)
      enddo
c     do ie0=1,n0-1
c       print *, "fmat0[",ie0,",*] = ",
c    &    fmat0(ie0,-1),fmat0(ie0,0),fmat0(ie0,1)
c     enddo
      do ie1=1,n1-2
        ip1=ie1+1
        fmat1(ip1,-1)=fmat1(ip1,-1)/fmat1(ie1,0)
        fmat1(ip1,0)=fmat1(ip1,0)-fmat1(ip1,-1)*fmat1(ie1,1)
      enddo
c     do ie1=1,n1-1
c       print *, "fmat1[",ie1,",*] = ",
c    &    fmat1(ie1,-1),fmat1(ie1,0),fmat1(ie1,1)
c     enddo
c     print *, "leaving initialize"
c     print *, " "
c     call flush(6)
c     ******************************************************************
      return
      end

      subroutine stabilization_scheme(dt,n0,n1,
     &  fmat0,fmat1,mat0,mat1,uold,x0,x1,
     &  unew)
c     ******************************************************************
      integer n0,n1
      double precision dt
      double precision fmat0(1:n0-1,-1:1),fmat1(1:n1-1,-1:1),
     &  mat0(1:n0-1,-1:1),mat1(1:n1-1,-1:1),uold(0:n0,0:n1),
     &  x0(0:n0),x1(0:n1)
      double precision unew(0:n0,0:n1)
      integer ie0,ie1
c     ******************************************************************
c     print *, " "
c     print *, "in stabilization_scheme"
c     do ie0=1,n0-1
c       print *, "fmat0[",ie0,",*] = ",
c    &    fmat0(ie0,-1),fmat0(ie0,0),fmat0(ie0,1)
c     enddo
c     do ie1=1,n1-1
c       print *, "fmat1[",ie1,",*] = ",
c    &    fmat1(ie1,-1),fmat1(ie1,0),fmat1(ie1,1)
c     enddo
c     do ie0=1,n0-1
c       print *, "mat0[",ie0,",*] = ",
c    &    mat0(ie0,-1),mat0(ie0,0),mat0(ie0,1)
c     enddo
c     do ie1=1,n1-1
c       print *, "mat1[",ie1,",*] = ",
c    &    mat1(ie1,-1),mat1(ie1,0),mat1(ie1,1)
c     enddo
c     do ie1=0,n1
c       do ie0=0,n0
c         print *, "uold[",ie0,",",ie1,"] = ",uold(ie0,ie1)
c       enddo
c     enddo
c     do ie0=0,n0
c       print *, "x0[",ie0,"] = ",x0(ie0)
c     enddo
c     do ie1=0,n1
c       print *, "x1[",ie1,"] = ",x1(ie1)
c     enddo
c     call flush(6)

c     minus laplacian applied to uold:
      do ie1=1,n1-1
        do ie0=1,n0-1
          unew(ie0,ie1)=-mat0(ie0,-1)*uold(ie0-1,ie1  )
     &                  -mat0(ie0, 0)*uold(ie0  ,ie1  )
     &                  -mat0(ie0, 1)*uold(ie0+1,ie1  )
     &                  -mat1(ie1,-1)*uold(ie0  ,ie1-1)
     &                  -mat1(ie1, 0)*uold(ie0  ,ie1  )
     &                  -mat1(ie1, 1)*uold(ie0  ,ie1+1)
        enddo
      enddo
c     solve (I+A_1*dt) v = - Laplacian * uold
      do ie1=1,n1-1
        do ie0=2,n0-1
          unew(ie0,ie1)=unew(ie0,ie1)-fmat0(ie0,-1)*unew(ie0-1,ie1)
        enddo
        unew(n0-1,ie1)=unew(n0-1,ie1)/fmat0(n0-1,0)
        do ie0=n0-2,1,-1
          unew(ie0,ie1)=(unew(ie0,ie1)-fmat0(ie0,1)*unew(ie0+1,ie1))
     &                 /fmat0(ie0,0)
        enddo
      enddo
c     solve (I+A_2*dt) w = v
      do ie0=1,n0-1
        do ie1=2,n1-1
          unew(ie0,ie1)=unew(ie0,ie1)-fmat1(ie1,-1)*unew(ie0,ie1-1)
        enddo
        unew(ie0,n1-1)=unew(ie0,n1-1)/fmat1(n1-1,0)
        do ie1=n1-2,1,-1
          unew(ie0,ie1)=(unew(ie0,ie1)-fmat1(ie1,1)*unew(ie0,ie1+1))
     &                 /fmat1(ie1,0)
        enddo
      enddo
c     compute unew = uold + dt*w
c     homogeneous Dirichlet boundary conditions
      ie1=0
        do ie0=0,n0
          unew(ie0,ie1)=0.d0
        enddo
      do ie1=1,n1-1
        ie0=0
          unew(ie0,ie1)=0.d0
        do ie0=1,n0-1
          unew(ie0,ie1)=uold(ie0,ie1)+dt*unew(ie0,ie1)
        enddo
        ie0=n0
          unew(ie0,ie1)=0.d0
      enddo
      ie1=n1
        do ie0=0,n0
          unew(ie0,ie1)=0.d0
        enddo

c     do ie1=0,n1
c       do ie0=0,n0
c         print *, "unew[",ie0,",",ie1,"] = ",unew(ie0,ie1)
c       enddo
c     enddo
c     print *, "leaving stabilization_scheme"
c     print *, " "
c     call flush(6)
c     ******************************************************************
      return
      end

