#ifndef EIGEH_H
#define EIGEH_H "$Header:$"
//----------------------------  eigen.h  ---------------------------
//   $Id: eigen.h,v 1.22 2003/04/30 23:01:57 wolf Exp $
//   Version: $Name: Version-4-0-0 $
//
//   Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003 by the deal.II authors
//
//   This file is subject to QPL and may not be  distributed
//   without copyright and license information. Please refer
//   to the file deal.II/doc/license.html for the  text  and
//   further information on this license.
//
//----------------------------  eigen.h  ---------------------------
//
//modified fromdeal.II/lac/include/lac/eigen.h
//  by John Trangenstein, August 2009
//**********************************************************************
// Copyright 2009 John A. Trangenstein
//
// This software is made available for research and instructional use 
// only. 
// You may copy and use this software without charge for these 
// non-commercial purposes, provided that the copyright notice and 
// associated text is reproduced on all copies.  
// For all other uses (including distribution of modified versions), 
// please contact the author at
//   John A. Trangenstein
//   Department of Mathematics
//   Duke University
//   Durham, NC 27708-0320
//   USA
// or
//   johnt@math.duke.edu
// 
// This software is made available "as is" without any assurance that it
// is completely correct, or that it will work for your purposes.  
// Use the software at your own risk.
//**********************************************************************

#include <cmath>
#include <Solver.H>

//compare to DEAL EigenPower
class EigenPower : private Solver {
  private:
    REAL shift;
  public:
    EigenPower(SolverControl &cn,REAL s=0.) : Solver(cn),shift(s) {}
    virtual ~EigenPower() {}
    void solve(const SolverMatrix&,Vector&,const Vector&,
      const SolverPreconditioner&) { OBSOLETE("not programmed"); }
    void solve(REAL&,const SolverMatrix&,Vector&);
};

//compare to DEAL EigenInverse
class EigenInverse : private Solver {
  private:
    REAL relaxation;
    int start_adaption;
    bool use_residual;
  public:
    EigenInverse(SolverControl &cn,REAL r=1.,int sa=6,
    bool ur=true) : Solver(cn),relaxation(r),start_adaption(sa),
      use_residual(ur) {}
    virtual ~EigenInverse() {}
    void solve(const SolverMatrix&,Vector&,const Vector&,
      const SolverPreconditioner&) { OBSOLETE("not programmed"); }
    void solve(REAL &value,const SolverMatrix &A,Vector &x);
};

#endif
